module:    Dylan-user	
Synopsis:  This library defines data types, constants (including error codes),
	   and structure accessors that are shared by the other libraries for
	   the various parts of the Win32 API.
Copyright:    Original Code is Copyright (c) 1995-2004 Functional Objects, Inc.
              All rights reserved.
License:      See License.txt in this distribution for details.
Warranty:     Distributed WITHOUT WARRANTY OF ANY KIND


/* Automatically generated from "comlib.src"; do not edit. */


define library Win32-common
  use dylan;
  use common-dylan;
  use C-FFI;
  export Win32-common;
end;

define module Win32-common
  use common-dylan;
  use C-FFI , export: { null-pointer, null-pointer?, pointer-address,
		        pointer-value, pointer-value-setter, size-of,
		        <C-void*>, <C-pointer>, <C-string>, <C-unicode-string>,
		     	pointer-cast, destroy, \with-stack-structure,
		        pointer-value-address, c-type-cast,
		        c-callable-wrapper-definer, \with-c-string } ;
  use machine-words, 
    export: {%logior, %logand};
  use Dylan-extensions,
    import: { <abstract-integer>, <big-integer>,
	      <double-integer>, %double-integer-low, %double-integer-high };
  use win32-core, export: all;


  // from "windef.h":
  export <ULONG>, <PULONG>, <USHORT>, <PUSHORT>, <UCHAR>, <PUCHAR>,
	<PSZ>, $MAX-PATH, <DWORD>, <BOOL>, <C-BYTE>, <WORD>, <PFLOAT>,
	<PBOOL>, <LPBOOL>, <PBYTE>, <LPBYTE>, <PINT>, <LPINT>, <PWORD>,
	<LPWORD>, <LPLONG>, <PDWORD>, <LPDWORD>, <LPVOID>, <LPCVOID>;
  export <INT>, <ATOM>;
  export <SPHANDLE>, <LPHANDLE>, <HGLOBAL>, <HLOCAL>, <GLOBALHANDLE>,
	<LOCALHANDLE>;
  export <COLORREF>, <LPCOLORREF>, left-value, left-value-setter,
	top-value, top-value-setter, right-value, right-value-setter,
	bottom-value, bottom-value-setter, <RECT>, <LPRECT>, <PRECT>;
  export <LPCRECT>;
  export x-value, x-value-setter, y-value, y-value-setter, <POINT>,
	<LPPOINT>, <PPOINT>;
  export x-value, x-value-setter, y-value, y-value-setter, <POINTL>,
	<LPPOINTL>, <PPOINTL>;
  export cx-value, cx-value-setter, cy-value, cy-value-setter, <SIZE>,
	<LPSIZE>, <PSIZE>;
  export <SIZEL>, <PSIZEL>, <LPSIZEL>;
  export x-value, x-value-setter, y-value, y-value-setter, <POINTS>,
	<LPPOINTS>, <PPOINTS>, $DM-UPDATE, $DM-COPY, $DM-PROMPT, $DM-MODIFY,
	$DM-IN-BUFFER, $DM-IN-PROMPT, $DM-OUT-BUFFER, $DM-OUT-DEFAULT,
	$DC-FIELDS, $DC-PAPERS, $DC-PAPERSIZE, $DC-MINEXTENT, $DC-MAXEXTENT,
	$DC-BINS, $DC-DUPLEX, $DC-SIZE, $DC-EXTRA, $DC-VERSION, $DC-DRIVER,
	$DC-BINNAMES, $DC-ENUMRESOLUTIONS, $DC-FILEDEPENDENCIES,
	$DC-TRUETYPE, $DC-PAPERNAMES, $DC-ORIENTATION, $DC-COPIES;

  // from "winnt.h":
  export $ANYSIZE-ARRAY;
  export <PVOID>;
  export <CHAR>, <SHORT>, <LONG>;
  export <PWCHAR>, <LPWCH>, <PWCH>, <LPCWCH>, <PCWCH>, <NWPSTR>,
	<LPWSTR>, <PWSTR>;
  export <LPCWSTR>, <PCWSTR>;
  export <PCHAR>, <LPCH>, <PCH>;
  export <LPCCH>, <PCCH>, <NPSTR>, <LPSTR>, <PSTR>, <LPCSTR>, <PCSTR>;
  export <TCHAR>, <PTCHAR>, <LPTCH>, <PTCH>, <PTSTR>, <LPTSTR>,
	<LPCTSTR>;
  export <PSHORT>, <PLONG>, <PHANDLE>;
  export <FCHAR>, <FSHORT>, <FLONG>;
  export <CCHAR>, <LCID>, <PLCID>, <LANGID>, $APPLICATION-ERROR-MASK,
	$ERROR-SEVERITY-SUCCESS, $ERROR-SEVERITY-INFORMATIONAL,
	$ERROR-SEVERITY-WARNING, $ERROR-SEVERITY-ERROR;
  export $UNICODE-NULL;
  export $MAXCHAR, $MAXSHORT, $MAXLONG, $MAXBYTE, $MAXWORD, $MAXDWORD;
  export $LANG-NEUTRAL, $LANG-AFRIKAANS, $LANG-ALBANIAN, $LANG-ARABIC,
	$LANG-BASQUE, $LANG-BELARUSIAN, $LANG-BULGARIAN, $LANG-CATALAN,
	$LANG-CHINESE, $LANG-CROATIAN, $LANG-CZECH, $LANG-DANISH,
	$LANG-DUTCH, $LANG-ENGLISH, $LANG-ESTONIAN, $LANG-FAEROESE,
	$LANG-FARSI, $LANG-FINNISH, $LANG-FRENCH, $LANG-GERMAN, $LANG-GREEK,
	$LANG-HEBREW, $LANG-HINDI, $LANG-HUNGARIAN, $LANG-ICELANDIC,
	$LANG-INDONESIAN, $LANG-ITALIAN, $LANG-JAPANESE, $LANG-KOREAN,
	$LANG-LATVIAN, $LANG-LITHUANIAN, $LANG-MACEDONIAN, $LANG-MALAY,
	$LANG-NORWEGIAN, $LANG-POLISH, $LANG-PORTUGUESE, $LANG-ROMANIAN,
	$LANG-RUSSIAN, $LANG-SERBIAN, $LANG-SLOVAK, $LANG-SLOVENIAN,
	$LANG-SPANISH, $LANG-SWAHILI, $LANG-SWEDISH, $LANG-THAI,
	$LANG-TURKISH, $LANG-UKRAINIAN, $LANG-VIETNAMESE;
  export $SUBLANG-NEUTRAL, $SUBLANG-DEFAULT, $SUBLANG-SYS-DEFAULT,
	$SUBLANG-ARABIC-SAUDI-ARABIA, $SUBLANG-ARABIC-IRAQ,
	$SUBLANG-ARABIC-EGYPT, $SUBLANG-ARABIC-LIBYA,
	$SUBLANG-ARABIC-ALGERIA, $SUBLANG-ARABIC-MOROCCO,
	$SUBLANG-ARABIC-TUNISIA, $SUBLANG-ARABIC-OMAN, $SUBLANG-ARABIC-YEMEN,
	$SUBLANG-ARABIC-SYRIA, $SUBLANG-ARABIC-JORDAN,
	$SUBLANG-ARABIC-LEBANON, $SUBLANG-ARABIC-KUWAIT, $SUBLANG-ARABIC-UAE,
	$SUBLANG-ARABIC-BAHRAIN, $SUBLANG-ARABIC-QATAR,
	$SUBLANG-CHINESE-TRADITIONAL, $SUBLANG-CHINESE-SIMPLIFIED,
	$SUBLANG-CHINESE-HONGKONG, $SUBLANG-CHINESE-SINGAPORE,
	$SUBLANG-CHINESE-MACAU, $SUBLANG-DUTCH, $SUBLANG-DUTCH-BELGIAN,
	$SUBLANG-ENGLISH-US, $SUBLANG-ENGLISH-UK, $SUBLANG-ENGLISH-AUS,
	$SUBLANG-ENGLISH-CAN, $SUBLANG-ENGLISH-NZ, $SUBLANG-ENGLISH-EIRE,
	$SUBLANG-ENGLISH-SOUTH-AFRICA, $SUBLANG-ENGLISH-JAMAICA,
	$SUBLANG-ENGLISH-CARIBBEAN, $SUBLANG-ENGLISH-BELIZE,
	$SUBLANG-ENGLISH-TRINIDAD, $SUBLANG-ENGLISH-ZIMBABWE,
	$SUBLANG-ENGLISH-PHILIPPINES, $SUBLANG-FRENCH,
	$SUBLANG-FRENCH-BELGIAN, $SUBLANG-FRENCH-CANADIAN,
	$SUBLANG-FRENCH-SWISS, $SUBLANG-FRENCH-LUXEMBOURG,
	$SUBLANG-FRENCH-MONACO, $SUBLANG-GERMAN, $SUBLANG-GERMAN-SWISS,
	$SUBLANG-GERMAN-AUSTRIAN, $SUBLANG-GERMAN-LUXEMBOURG,
	$SUBLANG-GERMAN-LIECHTENSTEIN, $SUBLANG-ITALIAN,
	$SUBLANG-ITALIAN-SWISS, $SUBLANG-KOREAN, $SUBLANG-KOREAN-JOHAB,
	$SUBLANG-LITHUANIAN, $SUBLANG-LITHUANIAN-CLASSIC,
	$SUBLANG-MALAY-MALAYSIA, $SUBLANG-MALAY-BRUNEI-DARUSSALAM,
	$SUBLANG-NORWEGIAN-BOKMAL, $SUBLANG-NORWEGIAN-NYNORSK,
	$SUBLANG-PORTUGUESE, $SUBLANG-PORTUGUESE-BRAZILIAN,
	$SUBLANG-SERBIAN-LATIN, $SUBLANG-SERBIAN-CYRILLIC, $SUBLANG-SPANISH,
	$SUBLANG-SPANISH-MEXICAN, $SUBLANG-SPANISH-MODERN,
	$SUBLANG-SPANISH-GUATEMALA, $SUBLANG-SPANISH-COSTA-RICA,
	$SUBLANG-SPANISH-PANAMA, $SUBLANG-SPANISH-DOMINICAN-REPUBLIC,
	$SUBLANG-SPANISH-VENEZUELA, $SUBLANG-SPANISH-COLOMBIA,
	$SUBLANG-SPANISH-PERU, $SUBLANG-SPANISH-ARGENTINA,
	$SUBLANG-SPANISH-ECUADOR, $SUBLANG-SPANISH-CHILE,
	$SUBLANG-SPANISH-URUGUAY, $SUBLANG-SPANISH-PARAGUAY,
	$SUBLANG-SPANISH-BOLIVIA, $SUBLANG-SPANISH-EL-SALVADOR,
	$SUBLANG-SPANISH-HONDURAS, $SUBLANG-SPANISH-NICARAGUA,
	$SUBLANG-SPANISH-PUERTO-RICO, $SUBLANG-SWEDISH,
	$SUBLANG-SWEDISH-FINLAND;
  export $SORT-DEFAULT, $SORT-JAPANESE-XJIS, $SORT-JAPANESE-UNICODE,
	$SORT-CHINESE-BIG5, $SORT-CHINESE-PRCP, $SORT-CHINESE-UNICODE,
	$SORT-CHINESE-PRC, $SORT-KOREAN-KSC, $SORT-KOREAN-UNICODE,
	$SORT-GERMAN-PHONE-BOOK;
  export $NLS-VALID-LOCALE-MASK;
  export $LANG-SYSTEM-DEFAULT, $LANG-USER-DEFAULT,
	$LOCALE-SYSTEM-DEFAULT, $LOCALE-USER-DEFAULT;

  // from "winerror.h":
  export $ERROR-SUCCESS, $NO-ERROR, $ERROR-INVALID-FUNCTION,
	$ERROR-FILE-NOT-FOUND, $ERROR-PATH-NOT-FOUND,
	$ERROR-TOO-MANY-OPEN-FILES, $ERROR-ACCESS-DENIED,
	$ERROR-INVALID-HANDLE, $ERROR-ARENA-TRASHED,
	$ERROR-NOT-ENOUGH-MEMORY, $ERROR-INVALID-BLOCK,
	$ERROR-BAD-ENVIRONMENT, $ERROR-BAD-FORMAT, $ERROR-INVALID-ACCESS,
	$ERROR-INVALID-DATA, $ERROR-OUTOFMEMORY, $ERROR-INVALID-DRIVE,
	$ERROR-CURRENT-DIRECTORY, $ERROR-NOT-SAME-DEVICE,
	$ERROR-NO-MORE-FILES, $ERROR-WRITE-PROTECT, $ERROR-BAD-UNIT,
	$ERROR-NOT-READY, $ERROR-BAD-COMMAND, $ERROR-CRC, $ERROR-BAD-LENGTH,
	$ERROR-SEEK, $ERROR-NOT-DOS-DISK, $ERROR-SECTOR-NOT-FOUND,
	$ERROR-OUT-OF-PAPER, $ERROR-WRITE-FAULT, $ERROR-READ-FAULT,
	$ERROR-GEN-FAILURE, $ERROR-SHARING-VIOLATION, $ERROR-LOCK-VIOLATION,
	$ERROR-WRONG-DISK, $ERROR-SHARING-BUFFER-EXCEEDED, $ERROR-HANDLE-EOF,
	$ERROR-HANDLE-DISK-FULL, $ERROR-NOT-SUPPORTED, $ERROR-REM-NOT-LIST,
	$ERROR-DUP-NAME, $ERROR-BAD-NETPATH, $ERROR-NETWORK-BUSY,
	$ERROR-DEV-NOT-EXIST, $ERROR-TOO-MANY-CMDS, $ERROR-ADAP-HDW-ERR,
	$ERROR-BAD-NET-RESP, $ERROR-UNEXP-NET-ERR, $ERROR-BAD-REM-ADAP,
	$ERROR-PRINTQ-FULL, $ERROR-NO-SPOOL-SPACE, $ERROR-PRINT-CANCELLED,
	$ERROR-NETNAME-DELETED, $ERROR-NETWORK-ACCESS-DENIED,
	$ERROR-BAD-DEV-TYPE, $ERROR-BAD-NET-NAME, $ERROR-TOO-MANY-NAMES,
	$ERROR-TOO-MANY-SESS, $ERROR-SHARING-PAUSED, $ERROR-REQ-NOT-ACCEP,
	$ERROR-REDIR-PAUSED, $ERROR-FILE-EXISTS, $ERROR-CANNOT-MAKE,
	$ERROR-FAIL-I24, $ERROR-OUT-OF-STRUCTURES, $ERROR-ALREADY-ASSIGNED,
	$ERROR-INVALID-PASSWORD, $ERROR-INVALID-PARAMETER,
	$ERROR-NET-WRITE-FAULT, $ERROR-NO-PROC-SLOTS,
	$ERROR-TOO-MANY-SEMAPHORES, $ERROR-EXCL-SEM-ALREADY-OWNED,
	$ERROR-SEM-IS-SET, $ERROR-TOO-MANY-SEM-REQUESTS,
	$ERROR-INVALID-AT-INTERRUPT-TIME, $ERROR-SEM-OWNER-DIED,
	$ERROR-SEM-USER-LIMIT, $ERROR-DISK-CHANGE, $ERROR-DRIVE-LOCKED,
	$ERROR-BROKEN-PIPE, $ERROR-OPEN-FAILED, $ERROR-BUFFER-OVERFLOW,
	$ERROR-DISK-FULL, $ERROR-NO-MORE-SEARCH-HANDLES,
	$ERROR-INVALID-TARGET-HANDLE, $ERROR-INVALID-CATEGORY,
	$ERROR-INVALID-VERIFY-SWITCH, $ERROR-BAD-DRIVER-LEVEL,
	$ERROR-CALL-NOT-IMPLEMENTED, $ERROR-SEM-TIMEOUT,
	$ERROR-INSUFFICIENT-BUFFER, $ERROR-INVALID-NAME,
	$ERROR-INVALID-LEVEL, $ERROR-NO-VOLUME-LABEL, $ERROR-MOD-NOT-FOUND,
	$ERROR-PROC-NOT-FOUND, $ERROR-WAIT-NO-CHILDREN,
	$ERROR-CHILD-NOT-COMPLETE, $ERROR-DIRECT-ACCESS-HANDLE,
	$ERROR-NEGATIVE-SEEK, $ERROR-SEEK-ON-DEVICE, $ERROR-IS-JOIN-TARGET,
	$ERROR-IS-JOINED, $ERROR-IS-SUBSTED, $ERROR-NOT-JOINED,
	$ERROR-NOT-SUBSTED, $ERROR-JOIN-TO-JOIN, $ERROR-SUBST-TO-SUBST,
	$ERROR-JOIN-TO-SUBST, $ERROR-SUBST-TO-JOIN, $ERROR-BUSY-DRIVE,
	$ERROR-SAME-DRIVE, $ERROR-DIR-NOT-ROOT, $ERROR-DIR-NOT-EMPTY,
	$ERROR-IS-SUBST-PATH, $ERROR-IS-JOIN-PATH, $ERROR-PATH-BUSY,
	$ERROR-IS-SUBST-TARGET, $ERROR-SYSTEM-TRACE,
	$ERROR-INVALID-EVENT-COUNT, $ERROR-TOO-MANY-MUXWAITERS,
	$ERROR-INVALID-LIST-FORMAT, $ERROR-LABEL-TOO-LONG,
	$ERROR-TOO-MANY-TCBS, $ERROR-SIGNAL-REFUSED, $ERROR-DISCARDED,
	$ERROR-NOT-LOCKED, $ERROR-BAD-ARGUMENTS, $ERROR-BAD-PATHNAME,
	$ERROR-SIGNAL-PENDING, $ERROR-MAX-THRDS-REACHED, $ERROR-LOCK-FAILED,
	$ERROR-BUSY, $ERROR-CANCEL-VIOLATION,
	$ERROR-ATOMIC-LOCKS-NOT-SUPPORTED, $ERROR-INVALID-SEGMENT-NUMBER,
	$ERROR-INVALID-ORDINAL, $ERROR-ALREADY-EXISTS,
	$ERROR-INVALID-FLAG-NUMBER, $ERROR-SEM-NOT-FOUND,
	$ERROR-INVALID-STARTING-CODESEG, $ERROR-INVALID-STACKSEG,
	$ERROR-INVALID-MODULETYPE, $ERROR-INVALID-EXE-SIGNATURE,
	$ERROR-EXE-MARKED-INVALID, $ERROR-BAD-EXE-FORMAT,
	$ERROR-ITERATED-DATA-EXCEEDS-64k, $ERROR-INVALID-MINALLOCSIZE,
	$ERROR-DYNLINK-FROM-INVALID-RING, $ERROR-IOPL-NOT-ENABLED,
	$ERROR-INVALID-SEGDPL, $ERROR-AUTODATASEG-EXCEEDS-64k,
	$ERROR-RING2SEG-MUST-BE-MOVABLE, $ERROR-RELOC-CHAIN-XEEDS-SEGLIM,
	$ERROR-INFLOOP-IN-RELOC-CHAIN, $ERROR-ENVVAR-NOT-FOUND,
	$ERROR-NO-SIGNAL-SENT, $ERROR-FILENAME-EXCED-RANGE,
	$ERROR-RING2-STACK-IN-USE, $ERROR-META-EXPANSION-TOO-LONG,
	$ERROR-INVALID-SIGNAL-NUMBER, $ERROR-LOCKED, $ERROR-TOO-MANY-MODULES,
	$ERROR-NESTING-NOT-ALLOWED, $ERROR-EXE-MACHINE-TYPE-MISMATCH,
	$ERROR-BAD-PIPE, $ERROR-PIPE-BUSY, $ERROR-NO-DATA,
	$ERROR-PIPE-NOT-CONNECTED, $ERROR-MORE-DATA, $ERROR-VC-DISCONNECTED,
	$ERROR-INVALID-EA-NAME, $ERROR-EA-LIST-INCONSISTENT,
	$ERROR-NO-MORE-ITEMS, $ERROR-CANNOT-COPY, $ERROR-DIRECTORY,
	$ERROR-EAS-DIDNT-FIT, $ERROR-EA-FILE-CORRUPT, $ERROR-EA-TABLE-FULL,
	$ERROR-INVALID-EA-HANDLE, $ERROR-EAS-NOT-SUPPORTED, $ERROR-NOT-OWNER,
	$ERROR-TOO-MANY-POSTS, $ERROR-PARTIAL-COPY,
	$ERROR-OPLOCK-NOT-GRANTED, $ERROR-INVALID-OPLOCK-PROTOCOL,
	$ERROR-MR-MID-NOT-FOUND, $ERROR-INVALID-ADDRESS,
	$ERROR-ARITHMETIC-OVERFLOW, $ERROR-PIPE-CONNECTED,
	$ERROR-PIPE-LISTENING, $ERROR-EA-ACCESS-DENIED,
	$ERROR-OPERATION-ABORTED, $ERROR-IO-INCOMPLETE, $ERROR-IO-PENDING,
	$ERROR-NOACCESS, $ERROR-SWAPERROR, $ERROR-STACK-OVERFLOW,
	$ERROR-INVALID-MESSAGE, $ERROR-CAN-NOT-COMPLETE,
	$ERROR-INVALID-FLAGS, $ERROR-UNRECOGNIZED-VOLUME,
	$ERROR-FILE-INVALID, $ERROR-FULLSCREEN-MODE, $ERROR-NO-TOKEN,
	$ERROR-BADDB, $ERROR-BADKEY, $ERROR-CANTOPEN, $ERROR-CANTREAD,
	$ERROR-CANTWRITE, $ERROR-REGISTRY-RECOVERED, $ERROR-REGISTRY-CORRUPT,
	$ERROR-REGISTRY-IO-FAILED, $ERROR-NOT-REGISTRY-FILE,
	$ERROR-KEY-DELETED, $ERROR-NO-LOG-SPACE, $ERROR-KEY-HAS-CHILDREN,
	$ERROR-CHILD-MUST-BE-VOLATILE, $ERROR-NOTIFY-ENUM-DIR,
	$ERROR-DEPENDENT-SERVICES-RUNNING, $ERROR-INVALID-SERVICE-CONTROL,
	$ERROR-SERVICE-REQUEST-TIMEOUT, $ERROR-SERVICE-DATABASE-LOCKED,
	$ERROR-SERVICE-ALREADY-RUNNING, $ERROR-INVALID-SERVICE-ACCOUNT,
	$ERROR-SERVICE-DISABLED, $ERROR-CIRCULAR-DEPENDENCY,
	$ERROR-SERVICE-DOES-NOT-EXIST, $ERROR-SERVICE-CANNOT-ACCEPT-CTRL,
	$ERROR-SERVICE-NOT-ACTIVE, $ERROR-FAILED-SERVICE-CONTROLLER-CONNECT,
	$ERROR-EXCEPTION-IN-SERVICE, $ERROR-DATABASE-DOES-NOT-EXIST,
	$ERROR-SERVICE-SPECIFIC-ERROR, $ERROR-PROCESS-ABORTED,
	$ERROR-SERVICE-DEPENDENCY-FAIL, $ERROR-SERVICE-LOGON-FAILED,
	$ERROR-SERVICE-START-HANG, $ERROR-INVALID-SERVICE-LOCK,
	$ERROR-SERVICE-MARKED-FOR-DELETE, $ERROR-SERVICE-EXISTS,
	$ERROR-ALREADY-RUNNING-LKG, $ERROR-SERVICE-DEPENDENCY-DELETED,
	$ERROR-BOOT-ALREADY-ACCEPTED, $ERROR-SERVICE-NEVER-STARTED,
	$ERROR-DUPLICATE-SERVICE-NAME, $ERROR-DIFFERENT-SERVICE-ACCOUNT,
	$ERROR-CANNOT-DETECT-DRIVER-FAILURE,
	$ERROR-CANNOT-DETECT-PROCESS-ABORT, $ERROR-NO-RECOVERY-PROGRAM,
	$ERROR-END-OF-MEDIA, $ERROR-FILEMARK-DETECTED,
	$ERROR-BEGINNING-OF-MEDIA, $ERROR-SETMARK-DETECTED,
	$ERROR-NO-DATA-DETECTED, $ERROR-PARTITION-FAILURE,
	$ERROR-INVALID-BLOCK-LENGTH, $ERROR-DEVICE-NOT-PARTITIONED,
	$ERROR-UNABLE-TO-LOCK-MEDIA, $ERROR-UNABLE-TO-UNLOAD-MEDIA,
	$ERROR-MEDIA-CHANGED, $ERROR-BUS-RESET, $ERROR-NO-MEDIA-IN-DRIVE,
	$ERROR-NO-UNICODE-TRANSLATION, $ERROR-DLL-INIT-FAILED,
	$ERROR-SHUTDOWN-IN-PROGRESS, $ERROR-NO-SHUTDOWN-IN-PROGRESS,
	$ERROR-IO-DEVICE, $ERROR-SERIAL-NO-DEVICE, $ERROR-IRQ-BUSY,
	$ERROR-MORE-WRITES, $ERROR-COUNTER-TIMEOUT,
	$ERROR-FLOPPY-ID-MARK-NOT-FOUND, $ERROR-FLOPPY-WRONG-CYLINDER,
	$ERROR-FLOPPY-UNKNOWN-ERROR, $ERROR-FLOPPY-BAD-REGISTERS,
	$ERROR-DISK-RECALIBRATE-FAILED, $ERROR-DISK-OPERATION-FAILED,
	$ERROR-DISK-RESET-FAILED, $ERROR-EOM-OVERFLOW,
	$ERROR-NOT-ENOUGH-SERVER-MEMORY, $ERROR-POSSIBLE-DEADLOCK,
	$ERROR-MAPPED-ALIGNMENT, $ERROR-SET-POWER-STATE-VETOED,
	$ERROR-SET-POWER-STATE-FAILED, $ERROR-TOO-MANY-LINKS,
	$ERROR-OLD-WIN-VERSION, $ERROR-APP-WRONG-OS,
	$ERROR-SINGLE-INSTANCE-APP, $ERROR-RMODE-APP, $ERROR-INVALID-DLL,
	$ERROR-NO-ASSOCIATION, $ERROR-DDE-FAIL, $ERROR-DLL-NOT-FOUND,
	$ERROR-NO-MORE-USER-HANDLES, $ERROR-MESSAGE-SYNC-ONLY,
	$ERROR-SOURCE-ELEMENT-EMPTY, $ERROR-DESTINATION-ELEMENT-FULL,
	$ERROR-ILLEGAL-ELEMENT-ADDRESS, $ERROR-MAGAZINE-NOT-PRESENT,
	$ERROR-DEVICE-REINITIALIZATION-NEEDED,
	$ERROR-DEVICE-REQUIRES-CLEANING, $ERROR-DEVICE-DOOR-OPEN,
	$ERROR-DEVICE-NOT-CONNECTED, $ERROR-NOT-FOUND, $ERROR-NO-MATCH,
	$ERROR-SET-NOT-FOUND, $ERROR-POINT-NOT-FOUND,
	$ERROR-NO-TRACKING-SERVICE, $ERROR-NO-VOLUME-ID;
  export $ERROR-CONNECTED-OTHER-PASSWORD, $ERROR-BAD-USERNAME,
	$ERROR-NOT-CONNECTED, $ERROR-OPEN-FILES, $ERROR-ACTIVE-CONNECTIONS,
	$ERROR-DEVICE-IN-USE, $ERROR-BAD-DEVICE, $ERROR-CONNECTION-UNAVAIL,
	$ERROR-DEVICE-ALREADY-REMEMBERED, $ERROR-NO-NET-OR-BAD-PATH,
	$ERROR-BAD-PROVIDER, $ERROR-CANNOT-OPEN-PROFILE, $ERROR-BAD-PROFILE,
	$ERROR-NOT-CONTAINER, $ERROR-EXTENDED-ERROR,
	$ERROR-INVALID-GROUPNAME, $ERROR-INVALID-COMPUTERNAME,
	$ERROR-INVALID-EVENTNAME, $ERROR-INVALID-DOMAINNAME,
	$ERROR-INVALID-SERVICENAME, $ERROR-INVALID-NETNAME,
	$ERROR-INVALID-SHARENAME, $ERROR-INVALID-PASSWORDNAME,
	$ERROR-INVALID-MESSAGENAME, $ERROR-INVALID-MESSAGEDEST,
	$ERROR-SESSION-CREDENTIAL-CONFLICT,
	$ERROR-REMOTE-SESSION-LIMIT-EXCEEDED, $ERROR-DUP-DOMAINNAME,
	$ERROR-NO-NETWORK, $ERROR-CANCELLED, $ERROR-USER-MAPPED-FILE,
	$ERROR-CONNECTION-REFUSED, $ERROR-GRACEFUL-DISCONNECT,
	$ERROR-ADDRESS-ALREADY-ASSOCIATED, $ERROR-ADDRESS-NOT-ASSOCIATED,
	$ERROR-CONNECTION-INVALID, $ERROR-CONNECTION-ACTIVE,
	$ERROR-NETWORK-UNREACHABLE, $ERROR-HOST-UNREACHABLE,
	$ERROR-PROTOCOL-UNREACHABLE, $ERROR-PORT-UNREACHABLE,
	$ERROR-REQUEST-ABORTED, $ERROR-CONNECTION-ABORTED, $ERROR-RETRY,
	$ERROR-CONNECTION-COUNT-LIMIT, $ERROR-LOGIN-TIME-RESTRICTION,
	$ERROR-LOGIN-WKSTA-RESTRICTION, $ERROR-INCORRECT-ADDRESS,
	$ERROR-ALREADY-REGISTERED, $ERROR-SERVICE-NOT-FOUND,
	$ERROR-NOT-AUTHENTICATED, $ERROR-NOT-LOGGED-ON, $ERROR-CONTINUE,
	$ERROR-ALREADY-INITIALIZED, $ERROR-NO-MORE-DEVICES,
	$ERROR-NO-SUCH-SITE, $ERROR-DOMAIN-CONTROLLER-EXISTS,
	$ERROR-DS-NOT-INSTALLED;
  export $ERROR-INVALID-WINDOW-HANDLE, $ERROR-INVALID-MENU-HANDLE,
	$ERROR-INVALID-CURSOR-HANDLE, $ERROR-INVALID-ACCEL-HANDLE,
	$ERROR-INVALID-HOOK-HANDLE, $ERROR-INVALID-DWP-HANDLE,
	$ERROR-TLW-WITH-WSCHILD, $ERROR-CANNOT-FIND-WND-CLASS,
	$ERROR-HOTKEY-ALREADY-REGISTERED, $ERROR-CLASS-ALREADY-EXISTS,
	$ERROR-CLASS-DOES-NOT-EXIST, $ERROR-CLASS-HAS-WINDOWS,
	$ERROR-INVALID-INDEX, $ERROR-INVALID-ICON-HANDLE,
	$ERROR-PRIVATE-DIALOG-INDEX, $ERROR-LISTBOX-ID-NOT-FOUND,
	$ERROR-NO-WILDCARD-CHARACTERS, $ERROR-CLIPBOARD-NOT-OPEN,
	$ERROR-HOTKEY-NOT-REGISTERED, $ERROR-WINDOW-NOT-DIALOG,
	$ERROR-CONTROL-ID-NOT-FOUND, $ERROR-INVALID-COMBOBOX-MESSAGE,
	$ERROR-WINDOW-NOT-COMBOBOX, $ERROR-INVALID-EDIT-HEIGHT,
	$ERROR-DC-NOT-FOUND, $ERROR-INVALID-HOOK-FILTER,
	$ERROR-INVALID-FILTER-PROC, $ERROR-HOOK-NEEDS-HMOD,
	$ERROR-GLOBAL-ONLY-HOOK, $ERROR-JOURNAL-HOOK-SET,
	$ERROR-HOOK-NOT-INSTALLED, $ERROR-INVALID-LB-MESSAGE,
	$ERROR-SETCOUNT-ON-BAD-LB, $ERROR-LB-WITHOUT-TABSTOPS,
	$ERROR-CHILD-WINDOW-MENU, $ERROR-NO-SYSTEM-MENU,
	$ERROR-INVALID-MSGBOX-STYLE, $ERROR-INVALID-SPI-VALUE,
	$ERROR-SCREEN-ALREADY-LOCKED, $ERROR-HWNDS-HAVE-DIFF-PARENT,
	$ERROR-NOT-CHILD-WINDOW, $ERROR-INVALID-GW-COMMAND,
	$ERROR-NON-MDICHILD-WINDOW, $ERROR-POPUP-ALREADY-ACTIVE,
	$ERROR-NO-SCROLLBARS, $ERROR-INVALID-SCROLLBAR-RANGE,
	$ERROR-INVALID-SHOWWIN-COMMAND, $ERROR-NO-SYSTEM-RESOURCES,
	$ERROR-NONPAGED-SYSTEM-RESOURCES, $ERROR-PAGED-SYSTEM-RESOURCES,
	$ERROR-WORKING-SET-QUOTA, $ERROR-PAGEFILE-QUOTA,
	$ERROR-COMMITMENT-LIMIT, $ERROR-MENU-ITEM-NOT-FOUND,
	$ERROR-INVALID-KEYBOARD-HANDLE, $ERROR-HOOK-TYPE-NOT-ALLOWED,
	$ERROR-REQUIRES-INTERACTIVE-WINDOWSTATION, $ERROR-TIMEOUT,
	$ERROR-INVALID-MONITOR-HANDLE;
  export $ERROR-INSTALL-SERVICE, $ERROR-INSTALL-USEREXIT,
	$ERROR-INSTALL-FAILURE, $ERROR-INSTALL-SUSPEND,
	$ERROR-UNKNOWN-PRODUCT, $ERROR-UNKNOWN-FEATURE,
	$ERROR-UNKNOWN-COMPONENT, $ERROR-UNKNOWN-PROPERTY,
	$ERROR-INVALID-HANDLE-STATE, $ERROR-BAD-CONFIGURATION,
	$ERROR-INDEX-ABSENT, $ERROR-INSTALL-SOURCE-ABSENT,
	$ERROR-BAD-DATABASE-VERSION, $ERROR-PRODUCT-UNINSTALLED,
	$ERROR-BAD-QUERY-SYNTAX, $ERROR-INVALID-FIELD;
  export $ERROR-WINS-INTERNAL, $ERROR-CAN-NOT-DEL-LOCAL-WINS,
	$ERROR-STATIC-INIT, $ERROR-INC-BACKUP, $ERROR-FULL-BACKUP,
	$ERROR-REC-NON-EXISTENT, $ERROR-RPL-NOT-ALLOWED,
	$ERROR-DHCP-ADDRESS-CONFLICT;

  // types from "first.dylan":
  export <FARPROC>, <PROC>, <LPARAM>, <LRESULT>, <WPARAM>, 
	<UINT>, <PUINT>, <LPUINT>, <LPULONG>, <C-void**>, <LPLPVOID>,
	<LARGE-INTEGER>,  <PLARGE-INTEGER>,
	<ULARGE-INTEGER>, <PULARGE-INTEGER>; 
  export LowPart-value, LowPart-value-setter,
	HighPart-value, HighPart-value-setter;
  export <RECTL>, <PRECTL>, <LPRECTL>, <LPCRECTL>;
  export <C-BYTE*>;
  export <signed-char>,   <signed-short>,   <signed-int>,   <signed-long>,
         <unsigned-char>, <unsigned-short>, <unsigned-int>, <unsigned-long>;

  // API functions from "first.dylan":
  export LOWORD, HIWORD, MAKELONG, LPARAM-TO-XY;
  export LOBYTE, HIBYTE, MAKEWORD;
  export MAKELANGID, PRIMARYLANGID, SUBLANGID;
  export MAKELCID, LANGIDFROMLCID, SORTIDFROMLCID;
  export TEXT;

  // internal hack in "first.dylan":
  export $FFFFFFFF;
  export \open-accessor-definer;

  // API functions from "moretype.dylan":
  export MAKEINTRESOURCE;

  // convenience functions from "moretype.dylan":
  export %free;

  // convenience constants from "moretype.dylan":
  export $NULL-HANDLE, $NULL-HWND, $NULL-RECT, $NULL-POINT, $NULL-VOID,
	 $NULL-string, $NULL-HDC, $NULL-HMENU, $NULL-HINSTANCE;

  // types from "moretype.dylan":
  export <BOOLEAN-BYTE>, <WCHAR>;

  // callback macro and related names from "callback.dylan":
  export \callback-definer;
  export <WNDPROC>-callback-wrapper, <DLGPROC>-callback-wrapper,
    <LPOFNHOOKPROC>-callback-wrapper, <LPCCHOOKPROC>-callback-wrapper,
    <LPFRHOOKPROC>-callback-wrapper, <LPCFHOOKPROC>-callback-wrapper,
    <LPPRINTHOOKPROC>-callback-wrapper, <LPSETUPHOOKPROC>-callback-wrapper;

  // more shared generics in "first.dylan":
  export flags-value, flags-value-setter,
    Flink-value, Flink-value-setter,
    cbSize-value, cbSize-value-setter,
    offset-value, offset-value-setter,
    cb-value, cb-value-setter, dwFlags-value, dwFlags-value-setter,
    cbData-value, cbData-value-setter, lpData-value, lpData-value-setter,
    dwSize-value, dwSize-value-setter, wFlags-value, wFlags-value-setter,
    Buffer-value, Buffer-value-setter,
    u-value, u-value-setter, wSecond-value, wSecond-value-setter;
end;
