module:    Dylan-user	
Synopsis:  Win32 API for "Graphics Device Interface" - 
	   drawing graphics and text and printing, 
	   corresponding to "WINGDI.H" and "GDI32.DLL".
Copyright:    Original Code is Copyright (c) 1995-2004 Functional Objects, Inc.
              All rights reserved.
License:      See License.txt in this distribution for details.
Warranty:     Distributed WITHOUT WARRANTY OF ANY KIND


/* Automatically generated from "library.src"; do not edit. */


define library Win32-GDI
  use Dylan;
  use C-FFI;
  use Win32-common;

  export Win32-GDI;
end;


define module Win32-GDI
  use Dylan;
  use C-FFI;
  use Win32-common,
    /* have to export here names that are used as structure accessors in
       both modules. */
    export: { x-value, y-value, x-value-setter, y-value-setter,
	     cbData-value, cbData-value-setter,
	     dwSize-value, dwSize-value-setter,
	     wFlags-value, wFlags-value-setter, Buffer-value,
	     u-value, u-value-setter, wSecond-value, wSecond-value-setter,
	 /* the following are defined in both "windef.h" and "wingdi.h" */
	     $DM-UPDATE, $DM-COPY, $DM-PROMPT, $DM-MODIFY,
	     $DC-FIELDS, $DC-PAPERS, $DC-PAPERSIZE, $DC-MINEXTENT,
	     $DC-MAXEXTENT, $DC-BINS, $DC-DUPLEX, $DC-SIZE, $DC-EXTRA,
	     $DC-VERSION, $DC-DRIVER, $DC-BINNAMES, $DC-ENUMRESOLUTIONS,
	     $DC-FILEDEPENDENCIES, $DC-TRUETYPE, $DC-PAPERNAMES,
	     $DC-ORIENTATION, $DC-COPIES,
	 /* and export some other names for users of GDI functions */
	     <C-void*>, <HANDLE>, <HBITMAP>, <HBRUSH>, <HCOLORSPACE>,
	     <HDC>, <HENHMETAFILE>, <HFONT>, <HGDIOBJ>, <HGLOBAL>,
	     <HMETAFILE>, <HPALETTE>, <HPEN>, <HRGN>, <LPCSTR>, <LPPOINT>,
	     <LPRECT>, <LPSIZE>, <LPSTR>, <LPVOID>,
	     pointer-address, pointer-cast,
	     left-value, right-value, top-value, bottom-value,
	     cx-value, cy-value, cx-value-setter, cy-value-setter,
	     TEXT, null-handle, null-handle?,
	     $NULL-HANDLE, $NULL-RECT, $NULL-POINT, $NULL-VOID,
	     $NULL-string, $NULL-HDC
	    } ;


  // from "wingdi.h":
  export $R2-BLACK, $R2-NOTMERGEPEN, $R2-MASKNOTPEN, $R2-NOTCOPYPEN,
	$R2-MASKPENNOT, $R2-NOT, $R2-XORPEN, $R2-NOTMASKPEN, $R2-MASKPEN,
	$R2-NOTXORPEN, $R2-NOP, $R2-MERGENOTPEN, $R2-COPYPEN,
	$R2-MERGEPENNOT, $R2-MERGEPEN, $R2-WHITE, $R2-LAST, $SRCCOPY,
	$SRCPAINT, $SRCAND, $SRCINVERT, $SRCERASE, $NOTSRCCOPY, $NOTSRCERASE,
	$MERGECOPY, $MERGEPAINT, $PATCOPY, $PATPAINT, $PATINVERT, $DSTINVERT,
	$BLACKNESS, $WHITENESS, $GDI-ERROR, $HGDI-ERROR, $ERROR, $NULLREGION,
	$SIMPLEREGION, $COMPLEXREGION, $RGN-AND, $RGN-OR, $RGN-XOR,
	$RGN-DIFF, $RGN-COPY, $RGN-MIN, $RGN-MAX, $BLACKONWHITE,
	$WHITEONBLACK, $COLORONCOLOR, $HALFTONE, $MAXSTRETCHBLTMODE,
	$STRETCH-HALFTONE, $ALTERNATE, $WINDING, $POLYFILL-LAST,
	$TA-NOUPDATECP, $TA-UPDATECP, $TA-LEFT, $TA-RIGHT, $TA-CENTER,
	$TA-TOP, $TA-BOTTOM, $TA-BASELINE, $TA-RTLREADING, $VTA-BASELINE,
	$VTA-LEFT, $VTA-RIGHT, $VTA-CENTER, $VTA-BOTTOM, $VTA-TOP,
	$ETO-OPAQUE, $ETO-CLIPPED, $ETO-GLYPH-INDEX, $ETO-RTLREADING,
	$ETO-NUMERICSLOCAL, $ETO-NUMERICSLATIN, $ETO-IGNORELANGUAGE,
	$ASPECT-FILTERING, $DCB-RESET, $DCB-ACCUMULATE, $DCB-DIRTY, $DCB-SET,
	$DCB-ENABLE, $DCB-DISABLE, $META-SETBKCOLOR, $META-SETBKMODE,
	$META-SETMAPMODE, $META-SETROP2, $META-SETRELABS,
	$META-SETPOLYFILLMODE, $META-SETSTRETCHBLTMODE,
	$META-SETTEXTCHAREXTRA, $META-SETTEXTCOLOR,
	$META-SETTEXTJUSTIFICATION, $META-SETWINDOWORG, $META-SETWINDOWEXT,
	$META-SETVIEWPORTORG, $META-SETVIEWPORTEXT, $META-OFFSETWINDOWORG,
	$META-SCALEWINDOWEXT, $META-OFFSETVIEWPORTORG,
	$META-SCALEVIEWPORTEXT, $META-LINETO, $META-MOVETO,
	$META-EXCLUDECLIPRECT, $META-INTERSECTCLIPRECT, $META-ARC,
	$META-ELLIPSE, $META-FLOODFILL, $META-PIE, $META-RECTANGLE,
	$META-ROUNDRECT, $META-PATBLT, $META-SAVEDC, $META-SETPIXEL,
	$META-OFFSETCLIPRGN, $META-TEXTOUT, $META-BITBLT, $META-STRETCHBLT,
	$META-POLYGON, $META-POLYLINE, $META-ESCAPE, $META-RESTOREDC,
	$META-FILLREGION, $META-FRAMEREGION, $META-INVERTREGION,
	$META-PAINTREGION, $META-SELECTCLIPREGION, $META-SELECTOBJECT,
	$META-SETTEXTALIGN, $META-CHORD, $META-SETMAPPERFLAGS,
	$META-EXTTEXTOUT, $META-SETDIBTODEV, $META-SELECTPALETTE,
	$META-REALIZEPALETTE, $META-ANIMATEPALETTE, $META-SETPALENTRIES,
	$META-POLYPOLYGON, $META-RESIZEPALETTE, $META-DIBBITBLT,
	$META-DIBSTRETCHBLT, $META-DIBCREATEPATTERNBRUSH, $META-STRETCHDIB,
	$META-EXTFLOODFILL, $META-DELETEOBJECT, $META-CREATEPALETTE,
	$META-CREATEPATTERNBRUSH, $META-CREATEPENINDIRECT,
	$META-CREATEFONTINDIRECT, $META-CREATEBRUSHINDIRECT,
	$META-CREATEREGION, ptPosition-value, ptPosition-value-setter,
	ptSize-value, ptSize-value-setter, wStyle-value, wStyle-value-setter,
	wPattern-value, wPattern-value-setter, <DRAWPATRECT>,
	<LPDRAWPATRECT>, <PDRAWPATRECT>, $NEWFRAME, $ABORTDOC, $NEXTBAND,
	$SETCOLORTABLE, $GETCOLORTABLE, $FLUSHOUTPUT, $DRAFTMODE,
	$QUERYESCSUPPORT, $SETABORTPROC, $STARTDOC, $ENDDOC,
	$GETPHYSPAGESIZE, $GETPRINTINGOFFSET, $GETSCALINGFACTOR, $MFCOMMENT,
	$GETPENWIDTH, $SETCOPYCOUNT, $SELECTPAPERSOURCE, $DEVICEDATA,
	$PASSTHROUGH, $GETTECHNOLGY, $GETTECHNOLOGY, $SETLINECAP,
	$SETLINEJOIN, $SETMITERLIMIT, $BANDINFO, $DRAWPATTERNRECT,
	$GETVECTORPENSIZE, $GETVECTORBRUSHSIZE, $ENABLEDUPLEX,
	$GETSETPAPERBINS, $GETSETPRINTORIENT, $ENUMPAPERBINS, $SETDIBSCALING,
	$EPSPRINTING, $ENUMPAPERMETRICS, $GETSETPAPERMETRICS,
	$POSTSCRIPT-DATA, $POSTSCRIPT-IGNORE, $MOUSETRAILS, $GETDEVICEUNITS,
	$GETEXTENDEDTEXTMETRICS, $GETEXTENTTABLE, $GETPAIRKERNTABLE,
	$GETTRACKKERNTABLE, $EXTTEXTOUT, $GETFACENAME, $DOWNLOADFACE,
	$ENABLERELATIVEWIDTHS, $ENABLEPAIRKERNING, $SETKERNTRACK,
	$SETALLJUSTVALUES, $SETCHARSET, $STRETCHBLT, $GETSETSCREENPARAMS,
	$QUERYDIBSUPPORT, $BEGIN-PATH, $CLIP-TO-PATH, $END-PATH,
	$EXT-DEVICE-CAPS, $RESTORE-CTM, $SAVE-CTM, $SET-ARC-DIRECTION,
	$SET-BACKGROUND-COLOR, $SET-POLY-MODE, $SET-SCREEN-ANGLE,
	$SET-SPREAD, $TRANSFORM-CTM, $SET-CLIP-BOX, $SET-BOUNDS,
	$SET-MIRROR-MODE, $OPENCHANNEL, $DOWNLOADHEADER, $CLOSECHANNEL,
	$POSTSCRIPT-PASSTHROUGH, $ENCAPSULATED-POSTSCRIPT,
	$POSTSCRIPT-IDENTIFY, $POSTSCRIPT-INJECTION;
  export $PSIDENT-GDICENTRIC, $PSIDENT-PSCENTRIC;
  export DataBytes-value, DataBytes-value-setter,
	InjectionPoint-value, InjectionPoint-value-setter, <PSINJECTDATA>,
	<LPPSINJECTDATA>, <PPSINJECTDATA>;
  export $PSINJECT-APPEND, $PSINJECT-REPLACE;
  export $PSINJECT-BEGINSTREAM, $PSINJECT-PSADOBE, $PSINJECT-COMMENTS,
	$PSINJECT-BEGINDEFAULTS, $PSINJECT-ENDDEFAULTS,
	$PSINJECT-BEGINPROLOG, $PSINJECT-ENDPROLOG, $PSINJECT-BEGINSETUP,
	$PSINJECT-ENDSETUP, $PSINJECT-ENDPAGECOMMENTS,
	$PSINJECT-BEGINPAGESETUP, $PSINJECT-ENDPAGESETUP, $PSINJECT-SHOWPAGE,
	$PSINJECT-PAGETRAILER, $PSINJECT-TRAILER, $PSINJECT-EOF,
	$PSINJECT-ENDSTREAM, $PSINJECT-VMSAVE, $PSINJECT-VMRESTORE,
	$PSINJECT-DOCNEEDEDRES, $PSINJECT-DOCSUPPLIEDRES, $PSINJECT-PAGES,
	$PSINJECT-PAGEORDER, $PSINJECT-ORIENTATION, $PSINJECT-BOUNDINGBOX,
	$PSINJECT-PAGENUMBER, $PSINJECT-PAGEBBOX, $PSINJECT-MAX,
	$QDI-SETDIBITS, $QDI-GETDIBITS, $QDI-DIBTOSCREEN, $QDI-STRETCHDIB,
	$SP-NOTREPORTED, $SP-ERROR, $SP-APPABORT, $SP-USERABORT,
	$SP-OUTOFDISK, $SP-OUTOFMEMORY, $PR-JOBSTATUS, $OBJ-PEN, $OBJ-BRUSH,
	$OBJ-DC, $OBJ-METADC, $OBJ-PAL, $OBJ-FONT, $OBJ-BITMAP, $OBJ-REGION,
	$OBJ-METAFILE, $OBJ-MEMDC, $OBJ-EXTPEN, $OBJ-ENHMETADC,
	$OBJ-ENHMETAFILE, $MWT-IDENTITY, $MWT-LEFTMULTIPLY,
	$MWT-RIGHTMULTIPLY, $MWT-MIN, $MWT-MAX, eM11-value,
	eM11-value-setter, eM12-value, eM12-value-setter, eM21-value,
	eM21-value-setter, eM22-value, eM22-value-setter, eDx-value,
	eDx-value-setter, eDy-value, eDy-value-setter, <XFORM>, <LPXFORM>,
	<PXFORM>, bmType-value, bmType-value-setter, bmWidth-value,
	bmWidth-value-setter, bmHeight-value, bmHeight-value-setter,
	bmWidthBytes-value, bmWidthBytes-value-setter, bmPlanes-value,
	bmPlanes-value-setter, bmBitsPixel-value, bmBitsPixel-value-setter,
	bmBits-value, bmBits-value-setter, <BITMAP>, <LPBITMAP>, <PBITMAP>,
	rgbtBlue-value, rgbtBlue-value-setter, rgbtGreen-value,
	rgbtGreen-value-setter, rgbtRed-value, rgbtRed-value-setter,
	<RGBTRIPLE>, <LPRGBTRIPLE>;
  export rgbBlue-value, rgbBlue-value-setter, rgbGreen-value,
	rgbGreen-value-setter, rgbRed-value, rgbRed-value-setter, <RGBQUAD>,
	<LPRGBQUAD>, $CS-ENABLE, $CS-DISABLE, $CS-DELETE-TRANSFORM,
	<LCSCSTYPE>, $LCS-CALIBRATED-RGB, $LCS-DEVICE-RGB, $LCS-DEVICE-CMYK,
	<LCSGAMUTMATCH>, $LCS-GM-BUSINESS, $LCS-GM-GRAPHICS, $LCS-GM-IMAGES,
	$LCS-GM-ABS-COLORIMETRIC, $CM-OUT-OF-GAMUT, $CM-IN-GAMUT,
	<FXPT16DOT16>, <LPFXPT16DOT16>, <FXPT2DOT30>, <LPFXPT2DOT30>,
	ciexyzX-value, ciexyzX-value-setter, ciexyzY-value,
	ciexyzY-value-setter, ciexyzZ-value, ciexyzZ-value-setter, <CIEXYZ>,
	<LPCIEXYZ>;
  export ciexyzRed-value, ciexyzRed-value-setter, ciexyzGreen-value,
	ciexyzGreen-value-setter, ciexyzBlue-value, ciexyzBlue-value-setter,
	<CIEXYZTRIPLE>, <LPCIEXYZTRIPLE>, lcsSignature-value,
	lcsSignature-value-setter, lcsVersion-value, lcsVersion-value-setter,
	lcsSize-value, lcsSize-value-setter, lcsCSType-value,
	lcsCSType-value-setter, lcsIntent-value, lcsIntent-value-setter,
	lcsEndpoints-value, lcsEndpoints-value-setter, lcsGammaRed-value,
	lcsGammaRed-value-setter, lcsGammaGreen-value,
	lcsGammaGreen-value-setter, lcsGammaBlue-value,
	lcsGammaBlue-value-setter, lcsFilename-array,
	lcsFilename-array-setter, lcsFilename-value, <LOGCOLORSPACEA>,
	<LPLOGCOLORSPACEA>, <LOGCOLORSPACE>, <LPLOGCOLORSPACE>, bcSize-value,
	bcSize-value-setter, bcWidth-value, bcWidth-value-setter,
	bcHeight-value, bcHeight-value-setter, bcPlanes-value,
	bcPlanes-value-setter, bcBitCount-value, bcBitCount-value-setter,
	<BITMAPCOREHEADER>, <LPBITMAPCOREHEADER>, <PBITMAPCOREHEADER>;
  export biSize-value, biSize-value-setter, biWidth-value,
	biWidth-value-setter, biHeight-value, biHeight-value-setter,
	biPlanes-value, biPlanes-value-setter, biBitCount-value,
	biBitCount-value-setter, biCompression-value,
	biCompression-value-setter, biSizeImage-value,
	biSizeImage-value-setter, biXPelsPerMeter-value,
	biXPelsPerMeter-value-setter, biYPelsPerMeter-value,
	biYPelsPerMeter-value-setter, biClrUsed-value,
	biClrUsed-value-setter, biClrImportant-value,
	biClrImportant-value-setter, <BITMAPINFOHEADER>,
	<LPBITMAPINFOHEADER>, <PBITMAPINFOHEADER>, bV4Size-value,
	bV4Size-value-setter, bV4Width-value, bV4Width-value-setter,
	bV4Height-value, bV4Height-value-setter, bV4Planes-value,
	bV4Planes-value-setter, bV4BitCount-value, bV4BitCount-value-setter,
	bV4V4Compression-value, bV4V4Compression-value-setter,
	bV4SizeImage-value, bV4SizeImage-value-setter,
	bV4XPelsPerMeter-value, bV4XPelsPerMeter-value-setter,
	bV4YPelsPerMeter-value, bV4YPelsPerMeter-value-setter,
	bV4ClrUsed-value, bV4ClrUsed-value-setter, bV4ClrImportant-value,
	bV4ClrImportant-value-setter, bV4RedMask-value,
	bV4RedMask-value-setter, bV4GreenMask-value,
	bV4GreenMask-value-setter, bV4BlueMask-value,
	bV4BlueMask-value-setter, bV4AlphaMask-value,
	bV4AlphaMask-value-setter, bV4CSType-value, bV4CSType-value-setter,
	bV4Endpoints-value, bV4Endpoints-value-setter, bV4GammaRed-value,
	bV4GammaRed-value-setter, bV4GammaGreen-value,
	bV4GammaGreen-value-setter, bV4GammaBlue-value,
	bV4GammaBlue-value-setter, <BITMAPV4HEADER>, <LPBITMAPV4HEADER>,
	<PBITMAPV4HEADER>, $BI-RGB, $BI-RLE8, $BI-RLE4, $BI-BITFIELDS;
  export bmiHeader-value, bmiHeader-value-setter, bmiColors-array,
	bmiColors-array-setter, bmiColors-value, <BITMAPINFO>,
	<LPBITMAPINFO>, <PBITMAPINFO>;
  export bmciHeader-value, bmciHeader-value-setter, bmciColors-array,
	bmciColors-array-setter, bmciColors-value, <BITMAPCOREINFO>,
	<LPBITMAPCOREINFO>, <PBITMAPCOREINFO>, bfType-value,
	bfType-value-setter, bfSize-value, bfSize-value-setter,
	bfOffBits-value, bfOffBits-value-setter, <BITMAPFILEHEADER>,
	<LPBITMAPFILEHEADER>, <PBITMAPFILEHEADER>, fsUsb-array,
	fsUsb-array-setter, fsUsb-value, fsCsb-array, fsCsb-array-setter,
	fsCsb-value, <FONTSIGNATURE>, <LPFONTSIGNATURE>, <PFONTSIGNATURE>;
  export ciCharset-value, ciCharset-value-setter, ciACP-value,
	ciACP-value-setter, fs-value, fs-value-setter, <CHARSETINFO>,
	<LPCHARSETINFO>, <PCHARSETINFO>, $TCI-SRCCHARSET, $TCI-SRCCODEPAGE,
	$TCI-SRCFONTSIG, lsUsb-array, lsUsb-array-setter, lsUsb-value,
	lsCsbDefault-array, lsCsbDefault-array-setter, lsCsbDefault-value,
	lsCsbSupported-array, lsCsbSupported-array-setter,
	lsCsbSupported-value, <LOCALESIGNATURE>, <LPLOCALESIGNATURE>,
	<PLOCALESIGNATURE>;
  export objectHandle-array, objectHandle-array-setter,
	objectHandle-value, <HANDLETABLE>, <LPHANDLETABLE>, <PHANDLETABLE>;
  export rdSize-value, rdSize-value-setter, rdFunction-value,
	rdFunction-value-setter, rdParm-array, rdParm-array-setter,
	rdParm-value, <METARECORD>, <LPMETARECORD>, <PMETARECORD>;
  export mm-value, mm-value-setter, xExt-value, xExt-value-setter,
	yExt-value, yExt-value-setter, hMF-value, hMF-value-setter,
	<METAFILEPICT>, <LPMETAFILEPICT>, mtType-value, mtType-value-setter,
	mtHeaderSize-value, mtHeaderSize-value-setter, mtVersion-value,
	mtVersion-value-setter, mtSize-value, mtSize-value-setter,
	mtNoObjects-value, mtNoObjects-value-setter, mtMaxRecord-value,
	mtMaxRecord-value-setter, mtNoParameters-value,
	mtNoParameters-value-setter, <METAHEADER>, <LPMETAHEADER>,
	<PMETAHEADER>, iType-value, iType-value-setter, nSize-value,
	nSize-value-setter, dParm-array, dParm-array-setter, dParm-value,
	<ENHMETARECORD>, <LPENHMETARECORD>, <PENHMETARECORD>;
  export iType-value, iType-value-setter, nSize-value,
	nSize-value-setter, rclBounds-value, rclBounds-value-setter,
	rclFrame-value, rclFrame-value-setter, dSignature-value,
	dSignature-value-setter, nVersion-value, nVersion-value-setter,
	nBytes-value, nBytes-value-setter, nRecords-value,
	nRecords-value-setter, nHandles-value, nHandles-value-setter,
	nDescription-value, nDescription-value-setter, offDescription-value,
	offDescription-value-setter, nPalEntries-value,
	nPalEntries-value-setter, szlDevice-value, szlDevice-value-setter,
	szlMillimeters-value, szlMillimeters-value-setter,
	cbPixelFormat-value, cbPixelFormat-value-setter,
	offPixelFormat-value, offPixelFormat-value-setter, bOpenGL-value,
	bOpenGL-value-setter, <ENHMETAHEADER>, <LPENHMETAHEADER>,
	<PENHMETAHEADER>, $TMPF-FIXED-PITCH, $TMPF-VECTOR, $TMPF-DEVICE,
	$TMPF-TRUETYPE;
  export tmHeight-value, tmHeight-value-setter, tmAscent-value,
	tmAscent-value-setter, tmDescent-value, tmDescent-value-setter,
	tmInternalLeading-value, tmInternalLeading-value-setter,
	tmExternalLeading-value, tmExternalLeading-value-setter,
	tmAveCharWidth-value, tmAveCharWidth-value-setter,
	tmMaxCharWidth-value, tmMaxCharWidth-value-setter, tmWeight-value,
	tmWeight-value-setter, tmOverhang-value, tmOverhang-value-setter,
	tmDigitizedAspectX-value, tmDigitizedAspectX-value-setter,
	tmDigitizedAspectY-value, tmDigitizedAspectY-value-setter,
	tmFirstChar-value, tmFirstChar-value-setter, tmLastChar-value,
	tmLastChar-value-setter, tmDefaultChar-value,
	tmDefaultChar-value-setter, tmBreakChar-value,
	tmBreakChar-value-setter, tmItalic-value, tmItalic-value-setter,
	tmUnderlined-value, tmUnderlined-value-setter, tmStruckOut-value,
	tmStruckOut-value-setter, tmPitchAndFamily-value,
	tmPitchAndFamily-value-setter, tmCharSet-value,
	tmCharSet-value-setter, <TEXTMETRICA>, <LPTEXTMETRICA>,
	<PTEXTMETRICA>, <TEXTMETRIC>, <PTEXTMETRIC>, <LPTEXTMETRIC>,
	$NTM-REGULAR, $NTM-BOLD, $NTM-ITALIC, $NTM-NONNEGATIVE-AC,
	$NTM-OPENTYPE, $NTM-MULTIPLEMASTER, $NTM-MM-INSTANCE, $NTM-TYPE1,
	$NTM-DSIG, tmHeight-value, tmHeight-value-setter, tmAscent-value,
	tmAscent-value-setter, tmDescent-value, tmDescent-value-setter,
	tmInternalLeading-value, tmInternalLeading-value-setter,
	tmExternalLeading-value, tmExternalLeading-value-setter,
	tmAveCharWidth-value, tmAveCharWidth-value-setter,
	tmMaxCharWidth-value, tmMaxCharWidth-value-setter, tmWeight-value,
	tmWeight-value-setter, tmOverhang-value, tmOverhang-value-setter,
	tmDigitizedAspectX-value, tmDigitizedAspectX-value-setter,
	tmDigitizedAspectY-value, tmDigitizedAspectY-value-setter,
	tmFirstChar-value, tmFirstChar-value-setter, tmLastChar-value,
	tmLastChar-value-setter, tmDefaultChar-value,
	tmDefaultChar-value-setter, tmBreakChar-value,
	tmBreakChar-value-setter, tmItalic-value, tmItalic-value-setter,
	tmUnderlined-value, tmUnderlined-value-setter, tmStruckOut-value,
	tmStruckOut-value-setter, tmPitchAndFamily-value,
	tmPitchAndFamily-value-setter, tmCharSet-value,
	tmCharSet-value-setter, ntmFlags-value, ntmFlags-value-setter,
	ntmSizeEM-value, ntmSizeEM-value-setter, ntmCellHeight-value,
	ntmCellHeight-value-setter, ntmAvgWidth-value,
	ntmAvgWidth-value-setter, <NEWTEXTMETRICA>, <LPNEWTEXTMETRICA>,
	<PNEWTEXTMETRICA>, <NEWTEXTMETRIC>, <PNEWTEXTMETRIC>,
	<LPNEWTEXTMETRIC>, ntmTm-value, ntmTm-value-setter, ntmFontSig-value,
	ntmFontSig-value-setter, <NEWTEXTMETRICEXA>, <LPNEWTEXTMETRICEXA>,
	<NEWTEXTMETRICEX>, paXCount-value, paXCount-value-setter,
	paYCount-value, paYCount-value-setter, paXExt-value,
	paXExt-value-setter, paYExt-value, paYExt-value-setter, paRGBs-value,
	paRGBs-value-setter, <PELARRAY>, <LPPELARRAY>, <PPELARRAY>,
	lbStyle-value, lbStyle-value-setter, lbColor-value,
	lbColor-value-setter, lbHatch-value, lbHatch-value-setter,
	<LOGBRUSH>, <LPLOGBRUSH>, <PLOGBRUSH>;
  export <PATTERN>, <PPATTERN>, <NPPATTERN>, <LPPATTERN>,
	lopnStyle-value, lopnStyle-value-setter, lopnWidth-value,
	lopnWidth-value-setter, lopnColor-value, lopnColor-value-setter,
	<LOGPEN>, <LPLOGPEN>, <PLOGPEN>;
  export elpPenStyle-value, elpPenStyle-value-setter, elpWidth-value,
	elpWidth-value-setter, elpBrushStyle-value,
	elpBrushStyle-value-setter, elpColor-value, elpColor-value-setter,
	elpHatch-value, elpHatch-value-setter, elpNumEntries-value,
	elpNumEntries-value-setter, elpStyleEntry-array,
	elpStyleEntry-array-setter, elpStyleEntry-value, <EXTLOGPEN>,
	<LPEXTLOGPEN>, <PEXTLOGPEN>;
  export peRed-value, peRed-value-setter, peGreen-value,
	peGreen-value-setter, peBlue-value, peBlue-value-setter,
	peFlags-value, peFlags-value-setter, <PALETTEENTRY>,
	<LPPALETTEENTRY>, <PPALETTEENTRY>, palVersion-value,
	palVersion-value-setter, palNumEntries-value,
	palNumEntries-value-setter, palPalEntry-array,
	palPalEntry-array-setter, palPalEntry-value, <LOGPALETTE>,
	<LPLOGPALETTE>, <PLOGPALETTE>;
  export $LF-FACESIZE, lfHeight-value, lfHeight-value-setter,
	lfWidth-value, lfWidth-value-setter, lfEscapement-value,
	lfEscapement-value-setter, lfOrientation-value,
	lfOrientation-value-setter, lfWeight-value, lfWeight-value-setter,
	lfItalic-value, lfItalic-value-setter, lfUnderline-value,
	lfUnderline-value-setter, lfStrikeOut-value,
	lfStrikeOut-value-setter, lfCharSet-value, lfCharSet-value-setter,
	lfOutPrecision-value, lfOutPrecision-value-setter,
	lfClipPrecision-value, lfClipPrecision-value-setter, lfQuality-value,
	lfQuality-value-setter, lfPitchAndFamily-value,
	lfPitchAndFamily-value-setter, lfFaceName-array,
	lfFaceName-array-setter, lfFaceName-value, <LOGFONTA>, <LPLOGFONTA>,
	<PLOGFONTA>, <LOGFONT>, <PLOGFONT>, <LPLOGFONT>, $LF-FULLFACESIZE,
	elfLogFont-value, elfLogFont-value-setter, elfFullName-array,
	elfFullName-array-setter, elfFullName-value, elfStyle-array,
	elfStyle-array-setter, elfStyle-value, <ENUMLOGFONTA>,
	<LPENUMLOGFONTA>, <ENUMLOGFONT>, <LPENUMLOGFONT>, elfLogFont-value,
	elfLogFont-value-setter, elfFullName-array, elfFullName-array-setter,
	elfFullName-value, elfStyle-array, elfStyle-array-setter,
	elfStyle-value, elfScript-array, elfScript-array-setter,
	elfScript-value, <ENUMLOGFONTEXA>, <LPENUMLOGFONTEXA>,
	<ENUMLOGFONTEX>, <LPENUMLOGFONTEX>, $OUT-DEFAULT-PRECIS,
	$OUT-STRING-PRECIS, $OUT-CHARACTER-PRECIS, $OUT-STROKE-PRECIS,
	$OUT-TT-PRECIS, $OUT-DEVICE-PRECIS, $OUT-RASTER-PRECIS,
	$OUT-TT-ONLY-PRECIS, $OUT-OUTLINE-PRECIS, $OUT-SCREEN-OUTLINE-PRECIS,
	$CLIP-DEFAULT-PRECIS, $CLIP-CHARACTER-PRECIS, $CLIP-STROKE-PRECIS,
	$CLIP-MASK, $CLIP-LH-ANGLES, $CLIP-TT-ALWAYS, $CLIP-EMBEDDED,
	$DEFAULT-QUALITY, $DRAFT-QUALITY, $PROOF-QUALITY,
	$NONANTIALIASED-QUALITY, $ANTIALIASED-QUALITY, $DEFAULT-PITCH,
	$FIXED-PITCH, $VARIABLE-PITCH, $MONO-FONT, $ANSI-CHARSET,
	$DEFAULT-CHARSET, $SYMBOL-CHARSET, $SHIFTJIS-CHARSET,
	$HANGEUL-CHARSET, $HANGUL-CHARSET, $GB2312-CHARSET,
	$CHINESEBIG5-CHARSET, $OEM-CHARSET, $JOHAB-CHARSET, $HEBREW-CHARSET,
	$ARABIC-CHARSET, $GREEK-CHARSET, $TURKISH-CHARSET,
	$VIETNAMESE-CHARSET, $THAI-CHARSET, $EASTEUROPE-CHARSET,
	$RUSSIAN-CHARSET, $MAC-CHARSET, $BALTIC-CHARSET, $FS-LATIN1,
	$FS-LATIN2, $FS-CYRILLIC, $FS-GREEK, $FS-TURKISH, $FS-HEBREW,
	$FS-ARABIC, $FS-BALTIC, $FS-VIETNAMESE, $FS-THAI, $FS-JISJAPAN,
	$FS-CHINESESIMP, $FS-WANSUNG, $FS-CHINESETRAD, $FS-JOHAB, $FS-SYMBOL,
	$FF-DONTCARE, $FF-ROMAN, $FF-SWISS, $FF-MODERN, $FF-SCRIPT,
	$FF-DECORATIVE, $FW-DONTCARE, $FW-THIN, $FW-EXTRALIGHT, $FW-LIGHT,
	$FW-NORMAL, $FW-MEDIUM, $FW-SEMIBOLD, $FW-BOLD, $FW-EXTRABOLD,
	$FW-HEAVY, $FW-ULTRALIGHT, $FW-REGULAR, $FW-DEMIBOLD, $FW-ULTRABOLD,
	$FW-BLACK, $PANOSE-COUNT, $PAN-FAMILYTYPE-INDEX,
	$PAN-SERIFSTYLE-INDEX, $PAN-WEIGHT-INDEX, $PAN-PROPORTION-INDEX,
	$PAN-CONTRAST-INDEX, $PAN-STROKEVARIATION-INDEX, $PAN-ARMSTYLE-INDEX,
	$PAN-LETTERFORM-INDEX, $PAN-MIDLINE-INDEX, $PAN-XHEIGHT-INDEX,
	$PAN-CULTURE-LATIN, bFamilyType-value, bFamilyType-value-setter,
	bSerifStyle-value, bSerifStyle-value-setter, bWeight-value,
	bWeight-value-setter, bProportion-value, bProportion-value-setter,
	bContrast-value, bContrast-value-setter, bStrokeVariation-value,
	bStrokeVariation-value-setter, bArmStyle-value,
	bArmStyle-value-setter, bLetterform-value, bLetterform-value-setter,
	bMidline-value, bMidline-value-setter, bXHeight-value,
	bXHeight-value-setter, <PANOSE>, <LPPANOSE>, $PAN-ANY, $PAN-NO-FIT,
	$PAN-FAMILY-TEXT-DISPLAY, $PAN-FAMILY-SCRIPT, $PAN-FAMILY-DECORATIVE,
	$PAN-FAMILY-PICTORIAL, $PAN-SERIF-COVE, $PAN-SERIF-OBTUSE-COVE,
	$PAN-SERIF-SQUARE-COVE, $PAN-SERIF-OBTUSE-SQUARE-COVE,
	$PAN-SERIF-SQUARE, $PAN-SERIF-THIN, $PAN-SERIF-BONE,
	$PAN-SERIF-EXAGGERATED, $PAN-SERIF-TRIANGLE, $PAN-SERIF-NORMAL-SANS,
	$PAN-SERIF-OBTUSE-SANS, $PAN-SERIF-PERP-SANS, $PAN-SERIF-FLARED,
	$PAN-SERIF-ROUNDED, $PAN-WEIGHT-VERY-LIGHT, $PAN-WEIGHT-LIGHT,
	$PAN-WEIGHT-THIN, $PAN-WEIGHT-BOOK, $PAN-WEIGHT-MEDIUM,
	$PAN-WEIGHT-DEMI, $PAN-WEIGHT-BOLD, $PAN-WEIGHT-HEAVY,
	$PAN-WEIGHT-BLACK, $PAN-WEIGHT-NORD, $PAN-PROP-OLD-STYLE,
	$PAN-PROP-MODERN, $PAN-PROP-EVEN-WIDTH, $PAN-PROP-EXPANDED,
	$PAN-PROP-CONDENSED, $PAN-PROP-VERY-EXPANDED,
	$PAN-PROP-VERY-CONDENSED, $PAN-PROP-MONOSPACED, $PAN-CONTRAST-NONE,
	$PAN-CONTRAST-VERY-LOW, $PAN-CONTRAST-LOW, $PAN-CONTRAST-MEDIUM-LOW,
	$PAN-CONTRAST-MEDIUM, $PAN-CONTRAST-MEDIUM-HIGH, $PAN-CONTRAST-HIGH,
	$PAN-CONTRAST-VERY-HIGH, $PAN-STROKE-GRADUAL-DIAG,
	$PAN-STROKE-GRADUAL-TRAN, $PAN-STROKE-GRADUAL-VERT,
	$PAN-STROKE-GRADUAL-HORZ, $PAN-STROKE-RAPID-VERT,
	$PAN-STROKE-RAPID-HORZ, $PAN-STROKE-INSTANT-VERT,
	$PAN-STRAIGHT-ARMS-HORZ, $PAN-STRAIGHT-ARMS-WEDGE,
	$PAN-STRAIGHT-ARMS-VERT, $PAN-STRAIGHT-ARMS-SINGLE-SERIF,
	$PAN-STRAIGHT-ARMS-DOUBLE-SERIF, $PAN-BENT-ARMS-HORZ,
	$PAN-BENT-ARMS-WEDGE, $PAN-BENT-ARMS-VERT,
	$PAN-BENT-ARMS-SINGLE-SERIF, $PAN-BENT-ARMS-DOUBLE-SERIF,
	$PAN-LETT-NORMAL-CONTACT, $PAN-LETT-NORMAL-WEIGHTED,
	$PAN-LETT-NORMAL-BOXED, $PAN-LETT-NORMAL-FLATTENED,
	$PAN-LETT-NORMAL-ROUNDED, $PAN-LETT-NORMAL-OFF-CENTER,
	$PAN-LETT-NORMAL-SQUARE, $PAN-LETT-OBLIQUE-CONTACT,
	$PAN-LETT-OBLIQUE-WEIGHTED, $PAN-LETT-OBLIQUE-BOXED,
	$PAN-LETT-OBLIQUE-FLATTENED, $PAN-LETT-OBLIQUE-ROUNDED,
	$PAN-LETT-OBLIQUE-OFF-CENTER, $PAN-LETT-OBLIQUE-SQUARE,
	$PAN-MIDLINE-STANDARD-TRIMMED, $PAN-MIDLINE-STANDARD-POINTED,
	$PAN-MIDLINE-STANDARD-SERIFED, $PAN-MIDLINE-HIGH-TRIMMED,
	$PAN-MIDLINE-HIGH-POINTED, $PAN-MIDLINE-HIGH-SERIFED,
	$PAN-MIDLINE-CONSTANT-TRIMMED, $PAN-MIDLINE-CONSTANT-POINTED,
	$PAN-MIDLINE-CONSTANT-SERIFED, $PAN-MIDLINE-LOW-TRIMMED,
	$PAN-MIDLINE-LOW-POINTED, $PAN-MIDLINE-LOW-SERIFED,
	$PAN-XHEIGHT-CONSTANT-SMALL, $PAN-XHEIGHT-CONSTANT-STD,
	$PAN-XHEIGHT-CONSTANT-LARGE, $PAN-XHEIGHT-DUCKING-SMALL,
	$PAN-XHEIGHT-DUCKING-STD, $PAN-XHEIGHT-DUCKING-LARGE,
	$ELF-VENDOR-SIZE;
  export elfLogFont-value, elfLogFont-value-setter, elfFullName-array,
	elfFullName-array-setter, elfFullName-value, elfStyle-array,
	elfStyle-array-setter, elfStyle-value, elfVersion-value,
	elfVersion-value-setter, elfStyleSize-value,
	elfStyleSize-value-setter, elfMatch-value, elfMatch-value-setter,
	elfVendorId-array, elfVendorId-array-setter, elfVendorId-value,
	elfCulture-value, elfCulture-value-setter, elfPanose-value,
	elfPanose-value-setter, <EXTLOGFONTA>, <LPEXTLOGFONTA>,
	<PEXTLOGFONTA>, <EXTLOGFONT>, <PEXTLOGFONT>, <LPEXTLOGFONT>,
	$ELF-VERSION, $ELF-CULTURE-LATIN, $RASTER-FONTTYPE, $DEVICE-FONTTYPE,
	$TRUETYPE-FONTTYPE, $PC-RESERVED, $PC-EXPLICIT, $PC-NOCOLLAPSE,
	$TRANSPARENT, $OPAQUE, $BKMODE-LAST, $GM-COMPATIBLE, $GM-ADVANCED,
	$GM-LAST, $PT-CLOSEFIGURE, $PT-LINETO, $PT-BEZIERTO, $PT-MOVETO,
	$MM-TEXT, $MM-LOMETRIC, $MM-HIMETRIC, $MM-LOENGLISH, $MM-HIENGLISH,
	$MM-TWIPS, $MM-ISOTROPIC, $MM-ANISOTROPIC, $MM-MIN, $MM-MAX,
	$MM-MAX-FIXEDSCALE, $ABSOLUTE, $RELATIVE, $WHITE-BRUSH,
	$LTGRAY-BRUSH, $GRAY-BRUSH, $DKGRAY-BRUSH, $BLACK-BRUSH, $NULL-BRUSH,
	$HOLLOW-BRUSH, $WHITE-PEN, $BLACK-PEN, $NULL-PEN, $OEM-FIXED-FONT,
	$ANSI-FIXED-FONT, $ANSI-VAR-FONT, $SYSTEM-FONT, $DEVICE-DEFAULT-FONT,
	$DEFAULT-PALETTE, $DEFAULT-GUI-FONT, $STOCK-LAST, $CLR-INVALID,
	$BS-SOLID, $BS-NULL, $BS-HOLLOW, $BS-HATCHED, $BS-PATTERN,
	$BS-INDEXED, $BS-DIBPATTERN, $BS-DIBPATTERNPT, $BS-PATTERN8X8,
	$BS-DIBPATTERN8X8, $BS-MONOPATTERN, $HS-HORIZONTAL, $HS-VERTICAL,
	$HS-FDIAGONAL, $HS-BDIAGONAL, $HS-CROSS, $HS-DIAGCROSS, $PS-SOLID,
	$PS-DASH, $PS-DOT, $PS-DASHDOT, $PS-DASHDOTDOT, $PS-NULL,
	$PS-INSIDEFRAME, $PS-USERSTYLE, $PS-ALTERNATE, $PS-STYLE-MASK,
	$PS-ENDCAP-ROUND, $PS-ENDCAP-SQUARE, $PS-ENDCAP-FLAT,
	$PS-ENDCAP-MASK, $PS-JOIN-ROUND, $PS-JOIN-BEVEL, $PS-JOIN-MITER,
	$PS-JOIN-MASK, $PS-COSMETIC, $PS-GEOMETRIC, $PS-TYPE-MASK,
	$AD-COUNTERCLOCKWISE, $AD-CLOCKWISE, $DRIVERVERSION, $TECHNOLOGY,
	$HORZSIZE, $VERTSIZE, $HORZRES, $VERTRES, $BITSPIXEL, $PLANES,
	$NUMBRUSHES, $NUMPENS, $NUMMARKERS, $NUMFONTS, $NUMCOLORS,
	$PDEVICESIZE, $CURVECAPS, $LINECAPS, $POLYGONALCAPS, $TEXTCAPS,
	$CLIPCAPS, $RASTERCAPS, $ASPECTX, $ASPECTY, $ASPECTXY, $LOGPIXELSX,
	$LOGPIXELSY, $SIZEPALETTE, $NUMRESERVED, $COLORRES, $PHYSICALWIDTH,
	$PHYSICALHEIGHT, $PHYSICALOFFSETX, $PHYSICALOFFSETY, $SCALINGFACTORX,
	$SCALINGFACTORY, $VREFRESH, $DESKTOPVERTRES, $DESKTOPHORZRES,
	$BLTALIGNMENT, $DT-PLOTTER, $DT-RASDISPLAY, $DT-RASPRINTER,
	$DT-RASCAMERA, $DT-CHARSTREAM, $DT-METAFILE, $DT-DISPFILE, $CC-NONE,
	$CC-CIRCLES, $CC-PIE, $CC-CHORD, $CC-ELLIPSES, $CC-WIDE, $CC-STYLED,
	$CC-WIDESTYLED, $CC-INTERIORS, $CC-ROUNDRECT, $LC-NONE, $LC-POLYLINE,
	$LC-MARKER, $LC-POLYMARKER, $LC-WIDE, $LC-STYLED, $LC-WIDESTYLED,
	$LC-INTERIORS, $PC-NONE, $PC-POLYGON, $PC-RECTANGLE, $PC-WINDPOLYGON,
	$PC-TRAPEZOID, $PC-SCANLINE, $PC-WIDE, $PC-STYLED, $PC-WIDESTYLED,
	$PC-INTERIORS, $PC-POLYPOLYGON, $PC-PATHS, $CP-NONE, $CP-RECTANGLE,
	$CP-REGION, $TC-OP-CHARACTER, $TC-OP-STROKE, $TC-CP-STROKE,
	$TC-CR-90, $TC-CR-ANY, $TC-SF-X-YINDEP, $TC-SA-DOUBLE,
	$TC-SA-INTEGER, $TC-SA-CONTIN, $TC-EA-DOUBLE, $TC-IA-ABLE,
	$TC-UA-ABLE, $TC-SO-ABLE, $TC-RA-ABLE, $TC-VA-ABLE, $TC-RESERVED,
	$TC-SCROLLBLT, $RC-BITBLT, $RC-BANDING, $RC-SCALING, $RC-BITMAP64,
	$RC-GDI20-OUTPUT, $RC-GDI20-STATE, $RC-SAVEBITMAP, $RC-DI-BITMAP,
	$RC-PALETTE, $RC-DIBTODEV, $RC-BIGFONT, $RC-STRETCHBLT,
	$RC-FLOODFILL, $RC-STRETCHDIB, $RC-OP-DX-OUTPUT, $RC-DEVBITS;
  export $DIB-RGB-COLORS, $DIB-PAL-COLORS, $SYSPAL-ERROR,
	$SYSPAL-STATIC, $SYSPAL-NOSTATIC, $SYSPAL-NOSTATIC256, $CBM-INIT,
	$FLOODFILLBORDER, $FLOODFILLSURFACE, $CCHDEVICENAME, $CCHFORMNAME,
	dmDeviceName-array, dmDeviceName-array-setter, dmDeviceName-value,
	dmSpecVersion-value, dmSpecVersion-value-setter,
	dmDriverVersion-value, dmDriverVersion-value-setter, dmSize-value,
	dmSize-value-setter, dmDriverExtra-value, dmDriverExtra-value-setter,
	dmFields-value, dmFields-value-setter, dmOrientation-value,
	dmOrientation-value-setter, dmPaperSize-value,
	dmPaperSize-value-setter, dmPaperLength-value,
	dmPaperLength-value-setter, dmPaperWidth-value,
	dmPaperWidth-value-setter, dmPosition-value, dmPosition-value-setter,
	dmScale-value, dmScale-value-setter, dmCopies-value,
	dmCopies-value-setter, dmDefaultSource-value,
	dmDefaultSource-value-setter, dmPrintQuality-value,
	dmPrintQuality-value-setter, dmColor-value, dmColor-value-setter,
	dmDuplex-value, dmDuplex-value-setter, dmYResolution-value,
	dmYResolution-value-setter, dmTTOption-value,
	dmTTOption-value-setter, dmCollate-value, dmCollate-value-setter,
	dmFormName-array, dmFormName-array-setter, dmFormName-value,
	dmLogPixels-value, dmLogPixels-value-setter, dmBitsPerPel-value,
	dmBitsPerPel-value-setter, dmPelsWidth-value,
	dmPelsWidth-value-setter, dmPelsHeight-value,
	dmPelsHeight-value-setter, dmDisplayFlags-value,
	dmDisplayFlags-value-setter, dmDisplayFrequency-value,
	dmDisplayFrequency-value-setter, dmICMMethod-value,
	dmICMMethod-value-setter, dmICMIntent-value,
	dmICMIntent-value-setter, dmMediaType-value,
	dmMediaType-value-setter, dmDitherType-value,
	dmDitherType-value-setter, <DEVMODEA>, <LPDEVMODEA>, <PDEVMODEA>,
	<DEVMODE>, <PDEVMODE>, <LPDEVMODE>, $DM-SPECVERSION, $DM-ORIENTATION,
	$DM-PAPERSIZE, $DM-PAPERLENGTH, $DM-PAPERWIDTH, $DM-SCALE,
	$DM-COPIES, $DM-DEFAULTSOURCE, $DM-PRINTQUALITY, $DM-COLOR,
	$DM-DUPLEX, $DM-YRESOLUTION, $DM-TTOPTION, $DM-COLLATE, $DM-FORMNAME,
	$DM-LOGPIXELS, $DM-BITSPERPEL, $DM-PELSWIDTH, $DM-PELSHEIGHT,
	$DM-DISPLAYFLAGS, $DM-DISPLAYFREQUENCY, $DM-ICMMETHOD, $DM-ICMINTENT,
	$DM-MEDIATYPE, $DM-DITHERTYPE, $DM-PANNINGWIDTH, $DM-PANNINGHEIGHT,
	$DMORIENT-PORTRAIT, $DMORIENT-LANDSCAPE, $DMPAPER-FIRST,
	$DMPAPER-LETTER, $DMPAPER-LETTERSMALL, $DMPAPER-TABLOID,
	$DMPAPER-LEDGER, $DMPAPER-LEGAL, $DMPAPER-STATEMENT,
	$DMPAPER-EXECUTIVE, $DMPAPER-A3, $DMPAPER-A4, $DMPAPER-A4SMALL,
	$DMPAPER-A5, $DMPAPER-B4, $DMPAPER-B5, $DMPAPER-FOLIO,
	$DMPAPER-QUARTO, $DMPAPER-10X14, $DMPAPER-11X17, $DMPAPER-NOTE,
	$DMPAPER-ENV-9, $DMPAPER-ENV-10, $DMPAPER-ENV-11, $DMPAPER-ENV-12,
	$DMPAPER-ENV-14, $DMPAPER-CSHEET, $DMPAPER-DSHEET, $DMPAPER-ESHEET,
	$DMPAPER-ENV-DL, $DMPAPER-ENV-C5, $DMPAPER-ENV-C3, $DMPAPER-ENV-C4,
	$DMPAPER-ENV-C6, $DMPAPER-ENV-C65, $DMPAPER-ENV-B4, $DMPAPER-ENV-B5,
	$DMPAPER-ENV-B6, $DMPAPER-ENV-ITALY, $DMPAPER-ENV-MONARCH,
	$DMPAPER-ENV-PERSONAL, $DMPAPER-FANFOLD-US,
	$DMPAPER-FANFOLD-STD-GERMAN, $DMPAPER-FANFOLD-LGL-GERMAN,
	$DMPAPER-ISO-B4, $DMPAPER-JAPANESE-POSTCARD, $DMPAPER-9X11,
	$DMPAPER-10X11, $DMPAPER-15X11, $DMPAPER-ENV-INVITE,
	$DMPAPER-RESERVED-48, $DMPAPER-RESERVED-49, $DMPAPER-LETTER-EXTRA,
	$DMPAPER-LEGAL-EXTRA, $DMPAPER-TABLOID-EXTRA, $DMPAPER-A4-EXTRA,
	$DMPAPER-LETTER-TRANSVERSE, $DMPAPER-A4-TRANSVERSE,
	$DMPAPER-LETTER-EXTRA-TRANSVERSE, $DMPAPER-A-PLUS, $DMPAPER-B-PLUS,
	$DMPAPER-LETTER-PLUS, $DMPAPER-A4-PLUS, $DMPAPER-A5-TRANSVERSE,
	$DMPAPER-B5-TRANSVERSE, $DMPAPER-A3-EXTRA, $DMPAPER-A5-EXTRA,
	$DMPAPER-B5-EXTRA, $DMPAPER-A2, $DMPAPER-A3-TRANSVERSE,
	$DMPAPER-A3-EXTRA-TRANSVERSE, $DMPAPER-LAST, $DMPAPER-USER,
	$DMBIN-FIRST, $DMBIN-UPPER, $DMBIN-ONLYONE, $DMBIN-LOWER,
	$DMBIN-MIDDLE, $DMBIN-MANUAL, $DMBIN-ENVELOPE, $DMBIN-ENVMANUAL,
	$DMBIN-AUTO, $DMBIN-TRACTOR, $DMBIN-SMALLFMT, $DMBIN-LARGEFMT,
	$DMBIN-LARGECAPACITY, $DMBIN-CASSETTE, $DMBIN-FORMSOURCE,
	$DMBIN-LAST, $DMBIN-USER, $DMRES-DRAFT, $DMRES-LOW, $DMRES-MEDIUM,
	$DMRES-HIGH, $DMCOLOR-MONOCHROME, $DMCOLOR-COLOR, $DMDUP-SIMPLEX,
	$DMDUP-VERTICAL, $DMDUP-HORIZONTAL, $DMTT-BITMAP, $DMTT-DOWNLOAD,
	$DMTT-SUBDEV, $DMTT-DOWNLOAD-OUTLINE, $DMCOLLATE-FALSE,
	$DMCOLLATE-TRUE, $DMDISPLAYFLAGS-TEXTMODE, $DMICMMETHOD-NONE,
	$DMICMMETHOD-SYSTEM, $DMICMMETHOD-DRIVER, $DMICMMETHOD-DEVICE,
	$DMICMMETHOD-USER, $DMICM-SATURATE, $DMICM-CONTRAST,
	$DMICM-COLORIMETRIC, $DMICM-ABS-COLORIMETRIC, $DMICM-USER,
	$DMMEDIA-STANDARD, $DMMEDIA-TRANSPARENCY, $DMMEDIA-GLOSSY,
	$DMMEDIA-USER, $DMDITHER-NONE, $DMDITHER-COARSE, $DMDITHER-FINE,
	$DMDITHER-LINEART, $DMDITHER-ERRORDIFFUSION, $DMDITHER-RESERVED6,
	$DMDITHER-RESERVED7, $DMDITHER-RESERVED8, $DMDITHER-RESERVED9,
	$DMDITHER-GRAYSCALE, $DMDITHER-USER;
  export DeviceName-array, DeviceName-array-setter, DeviceName-value,
	DeviceString-array, DeviceString-array-setter, DeviceString-value,
	StateFlags-value, StateFlags-value-setter, <DISPLAY-DEVICEA>,
	<LPDISPLAY-DEVICEA>, <PDISPLAY-DEVICEA>, <DISPLAY-DEVICE>,
	<PDISPLAY-DEVICE>, <LPDISPLAY-DEVICE>,
	$DISPLAY-DEVICE-ATTACHED-TO-DESKTOP, $DISPLAY-DEVICE-MULTI-DRIVER,
	$DISPLAY-DEVICE-PRIMARY-DEVICE, $DISPLAY-DEVICE-MIRRORING-DRIVER,
	$DISPLAY-DEVICE-VGA-COMPATIBLE, $RDH-RECTANGLES, iType-value,
	iType-value-setter, nCount-value, nCount-value-setter,
	nRgnSize-value, nRgnSize-value-setter, rcBound-value,
	rcBound-value-setter, <RGNDATAHEADER>, <LPRGNDATAHEADER>,
	<PRGNDATAHEADER>;
  export rdh-value, rdh-value-setter, Buffer-array,
	Buffer-array-setter, <RGNDATA>, <LPRGNDATA>, <PRGNDATA>;
  export abcA-value, abcA-value-setter, abcB-value, abcB-value-setter,
	abcC-value, abcC-value-setter, <ABC>, <LPABC>, <PABC>;
  export abcfA-value, abcfA-value-setter, abcfB-value,
	abcfB-value-setter, abcfC-value, abcfC-value-setter, <ABCFLOAT>,
	<LPABCFLOAT>, <PABCFLOAT>, otmSize-value, otmSize-value-setter,
	otmTextMetrics-value, otmTextMetrics-value-setter, otmFiller-value,
	otmFiller-value-setter, otmPanoseNumber-value,
	otmPanoseNumber-value-setter, otmfsSelection-value,
	otmfsSelection-value-setter, otmfsType-value, otmfsType-value-setter,
	otmsCharSlopeRise-value, otmsCharSlopeRise-value-setter,
	otmsCharSlopeRun-value, otmsCharSlopeRun-value-setter,
	otmItalicAngle-value, otmItalicAngle-value-setter, otmEMSquare-value,
	otmEMSquare-value-setter, otmAscent-value, otmAscent-value-setter,
	otmDescent-value, otmDescent-value-setter, otmLineGap-value,
	otmLineGap-value-setter, otmsCapEmHeight-value,
	otmsCapEmHeight-value-setter, otmsXHeight-value,
	otmsXHeight-value-setter, otmrcFontBox-value,
	otmrcFontBox-value-setter, otmMacAscent-value,
	otmMacAscent-value-setter, otmMacDescent-value,
	otmMacDescent-value-setter, otmMacLineGap-value,
	otmMacLineGap-value-setter, otmusMinimumPPEM-value,
	otmusMinimumPPEM-value-setter, otmptSubscriptSize-value,
	otmptSubscriptSize-value-setter, otmptSubscriptOffset-value,
	otmptSubscriptOffset-value-setter, otmptSuperscriptSize-value,
	otmptSuperscriptSize-value-setter, otmptSuperscriptOffset-value,
	otmptSuperscriptOffset-value-setter, otmsStrikeoutSize-value,
	otmsStrikeoutSize-value-setter, otmsStrikeoutPosition-value,
	otmsStrikeoutPosition-value-setter, otmsUnderscoreSize-value,
	otmsUnderscoreSize-value-setter, otmsUnderscorePosition-value,
	otmsUnderscorePosition-value-setter, otmpFamilyName-value,
	otmpFamilyName-value-setter, otmpFaceName-value,
	otmpFaceName-value-setter, otmpStyleName-value,
	otmpStyleName-value-setter, otmpFullName-value,
	otmpFullName-value-setter, <OUTLINETEXTMETRICA>,
	<LPOUTLINETEXTMETRICA>, <POUTLINETEXTMETRICA>, <OUTLINETEXTMETRIC>,
	<POUTLINETEXTMETRIC>, <LPOUTLINETEXTMETRIC>;
  export n-value, n-value-setter, lpstr-value, lpstr-value-setter,
	uiFlags-value, uiFlags-value-setter, rcl-value, rcl-value-setter,
	pdx-value, pdx-value-setter, <POLYTEXTA>, <LPPOLYTEXTA>,
	<PPOLYTEXTA>, <POLYTEXT>, <PPOLYTEXT>, <LPPOLYTEXT>, fract-value,
	fract-value-setter, value-value, value-value-setter, <FIXED>,
	<LPFIXED>;
  export eM11-value, eM11-value-setter, eM12-value, eM12-value-setter,
	eM21-value, eM21-value-setter, eM22-value, eM22-value-setter, <MAT2>,
	<LPMAT2>;
  export gmBlackBoxX-value, gmBlackBoxX-value-setter,
	gmBlackBoxY-value, gmBlackBoxY-value-setter, gmptGlyphOrigin-value,
	gmptGlyphOrigin-value-setter, gmCellIncX-value,
	gmCellIncX-value-setter, gmCellIncY-value, gmCellIncY-value-setter,
	<GLYPHMETRICS>, <LPGLYPHMETRICS>, $GGO-METRICS, $GGO-BITMAP,
	$GGO-NATIVE, $GGO-BEZIER, $GGO-GRAY2-BITMAP, $GGO-GRAY4-BITMAP,
	$GGO-GRAY8-BITMAP, $GGO-GLYPH-INDEX, $TT-POLYGON-TYPE, $TT-PRIM-LINE,
	$TT-PRIM-QSPLINE, $TT-PRIM-CSPLINE, <POINTFX>, <LPPOINTFX>;
  export wType-value, wType-value-setter, cpfx-value,
	cpfx-value-setter, apfx-array, apfx-array-setter, apfx-value,
	<TTPOLYCURVE>, <LPTTPOLYCURVE>;
  export dwType-value, dwType-value-setter, pfxStart-value,
	pfxStart-value-setter, <TTPOLYGONHEADER>, <LPTTPOLYGONHEADER>;
  export $GCP-DBCS, $GCP-REORDER, $GCP-USEKERNING, $GCP-GLYPHSHAPE,
	$GCP-LIGATE, $GCP-DIACRITIC, $GCP-KASHIDA, $GCP-ERROR, $FLI-MASK,
	$GCP-JUSTIFY, $FLI-GLYPHS, $GCP-CLASSIN, $GCP-MAXEXTENT,
	$GCP-JUSTIFYIN, $GCP-DISPLAYZWG, $GCP-SYMSWAPOFF,
	$GCP-NUMERICOVERRIDE, $GCP-NEUTRALOVERRIDE, $GCP-NUMERICSLATIN,
	$GCP-NUMERICSLOCAL, $GCPCLASS-LATIN, $GCPCLASS-HEBREW,
	$GCPCLASS-ARABIC, $GCPCLASS-NEUTRAL, $GCPCLASS-LOCALNUMBER,
	$GCPCLASS-LATINNUMBER, $GCPCLASS-LATINNUMERICTERMINATOR,
	$GCPCLASS-LATINNUMERICSEPARATOR, $GCPCLASS-NUMERICSEPARATOR,
	$GCPCLASS-PREBOUNDLTR, $GCPCLASS-PREBOUNDRTL, $GCPCLASS-POSTBOUNDLTR,
	$GCPCLASS-POSTBOUNDRTL, $GCPGLYPH-LINKBEFORE, $GCPGLYPH-LINKAFTER;
  export lStructSize-value, lStructSize-value-setter,
	lpOutString-value, lpOutString-value-setter, lpOrder-value,
	lpOrder-value-setter, lpDx-value, lpDx-value-setter,
	lpCaretPos-value, lpCaretPos-value-setter, lpClass-value,
	lpClass-value-setter, lpGlyphs-value, lpGlyphs-value-setter,
	nGlyphs-value, nGlyphs-value-setter, nMaxFit-value,
	nMaxFit-value-setter, <GCP-RESULTSA>, <LPGCP-RESULTSA>,
	<GCP-RESULTS>, <LPGCP-RESULTS>;
  export nSize-value, nSize-value-setter, nLanguageID-value,
	nLanguageID-value-setter, <RASTERIZER-STATUS>, <LPRASTERIZER-STATUS>,
	$TT-AVAILABLE, $TT-ENABLED, nSize-value, nSize-value-setter,
	nVersion-value, nVersion-value-setter, iPixelType-value,
	iPixelType-value-setter, cColorBits-value, cColorBits-value-setter,
	cRedBits-value, cRedBits-value-setter, cRedShift-value,
	cRedShift-value-setter, cGreenBits-value, cGreenBits-value-setter,
	cGreenShift-value, cGreenShift-value-setter, cBlueBits-value,
	cBlueBits-value-setter, cBlueShift-value, cBlueShift-value-setter,
	cAlphaBits-value, cAlphaBits-value-setter, cAlphaShift-value,
	cAlphaShift-value-setter, cAccumBits-value, cAccumBits-value-setter,
	cAccumRedBits-value, cAccumRedBits-value-setter,
	cAccumGreenBits-value, cAccumGreenBits-value-setter,
	cAccumBlueBits-value, cAccumBlueBits-value-setter,
	cAccumAlphaBits-value, cAccumAlphaBits-value-setter,
	cDepthBits-value, cDepthBits-value-setter, cStencilBits-value,
	cStencilBits-value-setter, cAuxBuffers-value,
	cAuxBuffers-value-setter, iLayerType-value, iLayerType-value-setter,
	dwLayerMask-value, dwLayerMask-value-setter, dwVisibleMask-value,
	dwVisibleMask-value-setter, dwDamageMask-value,
	dwDamageMask-value-setter, <PIXELFORMATDESCRIPTOR>,
	<LPPIXELFORMATDESCRIPTOR>, <PPIXELFORMATDESCRIPTOR>;
  export <FONTENUMPROCA>, <FONTENUMPROC>;
  export <GOBJENUMPROC>, <LINEDDAPROC>, AddFontResource,
	AnimatePalette, Arc, BitBlt, Chord, ChoosePixelFormat, CloseMetaFile,
	CombineRgn, CopyMetaFile, CreateBitmap, CreateBitmapIndirect,
	CreateBrushIndirect, CreateCompatibleBitmap, CreateDiscardableBitmap,
	CreateCompatibleDC, CreateDC, CreateDIBitmap, CreateDIBPatternBrush,
	CreateDIBPatternBrushPt, CreateEllipticRgn,
	CreateEllipticRgnIndirect, CreateFontIndirect, CreateFont,
	CreateHatchBrush, CreateIC, CreateMetaFile, CreatePalette, CreatePen,
	CreatePenIndirect, CreatePolyPolygonRgn, CreatePatternBrush,
	CreateRectRgn, CreateRectRgnIndirect, CreateRoundRectRgn,
	CreateScalableFontResource, CreateSolidBrush, DeleteDC,
	DeleteMetaFile, DeleteObject, DescribePixelFormat;
  export <LPFNDEVMODE>;
  export <LPFNDEVCAPS>, $DC-BINADJUST, $DC-EMF-COMPLIANT,
	$DC-DATATYPE-PRODUCED, $DC-COLLATE, $DC-MANUFACTURER, $DC-MODEL;
  export $DCTT-BITMAP, $DCTT-DOWNLOAD, $DCTT-SUBDEV,
	$DCTT-DOWNLOAD-OUTLINE, $DCBA-FACEUPNONE, $DCBA-FACEUPCENTER,
	$DCBA-FACEUPLEFT, $DCBA-FACEUPRIGHT, $DCBA-FACEDOWNNONE,
	$DCBA-FACEDOWNCENTER, $DCBA-FACEDOWNLEFT, $DCBA-FACEDOWNRIGHT,
	DrawEscape, Ellipse, EnumFontFamiliesEx, EnumFontFamilies,
	EnumObjects;
  export EqualRgn, Escape, ExtEscape, ExcludeClipRect,
	ExtCreateRegion, ExtFloodFill, FillRgn, FloodFill, FrameRgn, GetROP2,
	GetAspectRatioFilterEx, GetBkColor, GetBkMode, GetBitmapDimensionEx,
	GetBoundsRect, GetBrushOrgEx, GetCharWidth, GetCharWidth32,
	GetCharWidthFloat, GetCharABCWidths, GetCharABCWidthsFloat,
	GetClipBox, GetClipRgn, GetMetaRgn, GetCurrentObject,
	GetCurrentPositionEx, GetDeviceCaps, GetDIBits, GetFontData,
	GetGlyphOutline, GetGraphicsMode, GetMapMode, GetMetaFileBitsEx,
	GetMetaFile, GetNearestColor, GetNearestPaletteIndex, GetObjectType,
	GetOutlineTextMetrics, GetPaletteEntries, GetPixel, GetPixelFormat,
	GetPolyFillMode, GetRasterizerCaps, GetRegionData, GetRgnBox,
	GetStockObject, GetStretchBltMode, GetSystemPaletteEntries,
	GetSystemPaletteUse, GetTextCharacterExtra, GetTextAlign,
	GetTextColor, GetTextExtentPoint32, GetTextExtentExPoint,
	GetTextCharset, GetTextCharsetInfo, TranslateCharsetInfo,
	GetFontLanguageInfo, GetCharacterPlacement, GetViewportExtEx,
	GetViewportOrgEx, GetWindowExtEx, GetWindowOrgEx, IntersectClipRect,
	InvertRgn, LineDDA, LineTo, PlgBlt, OffsetClipRgn, OffsetRgn, PatBlt,
	Pie, PlayMetaFile, PaintRgn, PolyPolygon, PtInRegion, PtVisible,
	RectInRegion, RectVisible, Rectangle, RestoreDC, ResetDC,
	RealizePalette, RemoveFontResource, RoundRect, ResizePalette, SaveDC,
	SelectClipRgn, ExtSelectClipRgn, SetMetaRgn, SelectObject,
	SelectPalette, SetBkColor, SetBkMode, SetBitmapBits, SetBoundsRect,
	SetDIBits, SetDIBitsToDevice, SetMapperFlags, SetGraphicsMode,
	SetMapMode, SetMetaFileBitsEx, SetPaletteEntries, SetPixel,
	SetPixelV, SetPixelFormat, SetPolyFillMode, StretchBlt, SetRectRgn,
	StretchDIBits, SetROP2, SetStretchBltMode, SetSystemPaletteUse,
	SetTextCharacterExtra, SetTextColor, SetTextAlign,
	SetTextJustification, UpdateColors;
  export <COLOR16>;
  export Red-value, Red-value-setter, Green-value, Green-value-setter,
	Blue-value, Blue-value-setter, Alpha-value, Alpha-value-setter,
	<TRIVERTEX>, <LPTRIVERTEX>, <PTRIVERTEX>;
  export Vertex1-value, Vertex1-value-setter, Vertex2-value,
	Vertex2-value-setter, Vertex3-value, Vertex3-value-setter,
	<GRADIENT-TRIANGLE>, <LPGRADIENT-TRIANGLE>, <PGRADIENT-TRIANGLE>;
  export UpperLeft-value, UpperLeft-value-setter, LowerRight-value,
	LowerRight-value-setter, <GRADIENT-RECT>, <LPGRADIENT-RECT>,
	<PGRADIENT-RECT>;
  export BlendOp-value, BlendOp-value-setter, BlendFlags-value,
	BlendFlags-value-setter, SourceConstantAlpha-value,
	SourceConstantAlpha-value-setter, AlphaFormat-value,
	AlphaFormat-value-setter, <BLENDFUNCTION>, <LPBLENDFUNCTION>,
	<PBLENDFUNCTION>;
  export $AC-SRC-OVER;
  export $AC-SRC-NO-PREMULT-ALPHA, $AC-SRC-NO-ALPHA,
	$AC-DST-NO-PREMULT-ALPHA, $AC-DST-NO-ALPHA;
  export $GRADIENT-FILL-RECT-H, $GRADIENT-FILL-RECT-V,
	$GRADIENT-FILL-TRIANGLE, $GRADIENT-FILL-OP-FLAG;
  export PlayMetaFileRecord, <MFENUMPROC>, EnumMetaFile;
  export <ENHMFENUMPROC>, CloseEnhMetaFile, CopyEnhMetaFile,
	CreateEnhMetaFile, DeleteEnhMetaFile, EnumEnhMetaFile,
	GetEnhMetaFile, GetEnhMetaFileBits, GetEnhMetaFileDescription,
	GetEnhMetaFileHeader, GetEnhMetaFilePaletteEntries,
	GetWinMetaFileBits, PlayEnhMetaFile, PlayEnhMetaFileRecord,
	SetEnhMetaFileBits, SetWinMetaFileBits, GdiComment, GetTextMetrics;
  export dsBm-value, dsBm-value-setter, dsBmih-value,
	dsBmih-value-setter, dsBitfields-array, dsBitfields-array-setter,
	dsBitfields-value, dshSection-value, dshSection-value-setter,
	dsOffset-value, dsOffset-value-setter, <DIBSECTION>, <LPDIBSECTION>,
	<PDIBSECTION>, PolyPolyline, GetWorldTransform, SetWorldTransform,
	ModifyWorldTransform, CreateDIBSection, GetDIBColorTable,
	SetDIBColorTable, $CA-NEGATIVE, $CA-LOG-FILTER,
	$ILLUMINANT-DEVICE-DEFAULT, $ILLUMINANT-A, $ILLUMINANT-B,
	$ILLUMINANT-C, $ILLUMINANT-D50, $ILLUMINANT-D55, $ILLUMINANT-D65,
	$ILLUMINANT-D75, $ILLUMINANT-F2, $ILLUMINANT-MAX-INDEX,
	$ILLUMINANT-TUNGSTEN, $ILLUMINANT-DAYLIGHT, $ILLUMINANT-FLUORESCENT,
	$ILLUMINANT-NTSC, $RGB-GAMMA-MIN, $RGB-GAMMA-MAX,
	$REFERENCE-WHITE-MIN, $REFERENCE-WHITE-MAX, $REFERENCE-BLACK-MIN,
	$REFERENCE-BLACK-MAX, $COLOR-ADJ-MIN, $COLOR-ADJ-MAX, caSize-value,
	caSize-value-setter, caFlags-value, caFlags-value-setter,
	caIlluminantIndex-value, caIlluminantIndex-value-setter,
	caRedGamma-value, caRedGamma-value-setter, caGreenGamma-value,
	caGreenGamma-value-setter, caBlueGamma-value,
	caBlueGamma-value-setter, caReferenceBlack-value,
	caReferenceBlack-value-setter, caReferenceWhite-value,
	caReferenceWhite-value-setter, caContrast-value,
	caContrast-value-setter, caBrightness-value,
	caBrightness-value-setter, caColorfulness-value,
	caColorfulness-value-setter, caRedGreenTint-value,
	caRedGreenTint-value-setter, <COLORADJUSTMENT>, <LPCOLORADJUSTMENT>,
	<PCOLORADJUSTMENT>, SetColorAdjustment, GetColorAdjustment,
	CreateHalftonePalette, <ABORTPROC>;
  export lpszDocName-value, lpszDocName-value-setter,
	lpszOutput-value, lpszOutput-value-setter, lpszDatatype-value,
	lpszDatatype-value-setter, fwType-value, fwType-value-setter,
	<DOCINFOA>, <LPDOCINFOA>, <DOCINFO>, <LPDOCINFO>, $DI-APPBANDING,
	$DI-ROPS-READ-DESTINATION, StartDoc, EndDoc, StartPage, EndPage,
	AbortDoc, SetAbortProc, AbortPath, ArcTo, BeginPath, CloseFigure,
	EndPath, FillPath, FlattenPath, GetPath, PathToRegion,
	SelectClipPath, SetMiterLimit, StrokeAndFillPath, StrokePath,
	WidenPath, ExtCreatePen, GetMiterLimit, GetArcDirection, GetObject,
	MoveToEx, TextOut, ExtTextOut, PolyTextOut, CreatePolygonRgn, DPtoLP,
	LPtoDP, Polygon, Polyline, PolyBezier, PolyBezierTo, PolylineTo,
	SetViewportExtEx, SetViewportOrgEx, SetWindowExtEx, SetWindowOrgEx,
	OffsetViewportOrgEx, OffsetWindowOrgEx, ScaleViewportExtEx,
	ScaleWindowExtEx, SetBitmapDimensionEx, SetBrushOrgEx, GetTextFace,
	$FONTMAPPER-MAX, wFirst-value, wFirst-value-setter,
	iKernAmount-value, iKernAmount-value-setter, <KERNINGPAIR>,
	<LPKERNINGPAIR>, GetKerningPairs, GetDCOrgEx, UnrealizeObject,
	GdiFlush, GdiSetBatchLimit, GdiGetBatchLimit;
  export $ICM-OFF, $ICM-ON, $ICM-QUERY, $ICM-DONE-OUTSIDEDC,
	<ICMENUMPROCA>, SetICMMode, CheckColorsInGamut, GetColorSpace,
	GetLogColorSpace, CreateColorSpace, SetColorSpace, DeleteColorSpace,
	GetICMProfile, SetICMProfile, GetDeviceGammaRamp, SetDeviceGammaRamp,
	ColorMatchToTarget, EnumICMProfiles, $ENHMETA-SIGNATURE,
	$ENHMETA-STOCK-OBJECT, $EMR-HEADER, $EMR-POLYBEZIER, $EMR-POLYGON,
	$EMR-POLYLINE, $EMR-POLYBEZIERTO, $EMR-POLYLINETO, $EMR-POLYPOLYLINE,
	$EMR-POLYPOLYGON, $EMR-SETWINDOWEXTEX, $EMR-SETWINDOWORGEX,
	$EMR-SETVIEWPORTEXTEX, $EMR-SETVIEWPORTORGEX, $EMR-SETBRUSHORGEX,
	$EMR-EOF, $EMR-SETPIXELV, $EMR-SETMAPPERFLAGS, $EMR-SETMAPMODE,
	$EMR-SETBKMODE, $EMR-SETPOLYFILLMODE, $EMR-SETROP2,
	$EMR-SETSTRETCHBLTMODE, $EMR-SETTEXTALIGN, $EMR-SETCOLORADJUSTMENT,
	$EMR-SETTEXTCOLOR, $EMR-SETBKCOLOR, $EMR-OFFSETCLIPRGN,
	$EMR-MOVETOEX, $EMR-SETMETARGN, $EMR-EXCLUDECLIPRECT,
	$EMR-INTERSECTCLIPRECT, $EMR-SCALEVIEWPORTEXTEX,
	$EMR-SCALEWINDOWEXTEX, $EMR-SAVEDC, $EMR-RESTOREDC,
	$EMR-SETWORLDTRANSFORM, $EMR-MODIFYWORLDTRANSFORM, $EMR-SELECTOBJECT,
	$EMR-CREATEPEN, $EMR-CREATEBRUSHINDIRECT, $EMR-DELETEOBJECT,
	$EMR-ANGLEARC, $EMR-ELLIPSE, $EMR-RECTANGLE, $EMR-ROUNDRECT,
	$EMR-ARC, $EMR-CHORD, $EMR-PIE, $EMR-SELECTPALETTE,
	$EMR-CREATEPALETTE, $EMR-SETPALETTEENTRIES, $EMR-RESIZEPALETTE,
	$EMR-REALIZEPALETTE, $EMR-EXTFLOODFILL, $EMR-LINETO, $EMR-ARCTO,
	$EMR-POLYDRAW, $EMR-SETARCDIRECTION, $EMR-SETMITERLIMIT,
	$EMR-BEGINPATH, $EMR-ENDPATH, $EMR-CLOSEFIGURE, $EMR-FILLPATH,
	$EMR-STROKEANDFILLPATH, $EMR-STROKEPATH, $EMR-FLATTENPATH,
	$EMR-WIDENPATH, $EMR-SELECTCLIPPATH, $EMR-ABORTPATH, $EMR-GDICOMMENT,
	$EMR-FILLRGN, $EMR-FRAMERGN, $EMR-INVERTRGN, $EMR-PAINTRGN,
	$EMR-EXTSELECTCLIPRGN, $EMR-BITBLT, $EMR-STRETCHBLT, $EMR-MASKBLT,
	$EMR-PLGBLT, $EMR-SETDIBITSTODEVICE, $EMR-STRETCHDIBITS,
	$EMR-EXTCREATEFONTINDIRECTW, $EMR-EXTTEXTOUTA, $EMR-EXTTEXTOUTW,
	$EMR-POLYBEZIER16, $EMR-POLYGON16, $EMR-POLYLINE16,
	$EMR-POLYBEZIERTO16, $EMR-POLYLINETO16, $EMR-POLYPOLYLINE16,
	$EMR-POLYPOLYGON16, $EMR-POLYDRAW16, $EMR-CREATEMONOBRUSH,
	$EMR-CREATEDIBPATTERNBRUSHPT, $EMR-EXTCREATEPEN, $EMR-POLYTEXTOUTA,
	$EMR-POLYTEXTOUTW, $EMR-SETICMMODE, $EMR-CREATECOLORSPACE,
	$EMR-SETCOLORSPACE, $EMR-DELETECOLORSPACE, $EMR-GLSRECORD,
	$EMR-GLSBOUNDEDRECORD, $EMR-PIXELFORMAT, $EMR-MIN, $EMR-MAX,
	iType-value, iType-value-setter, nSize-value, nSize-value-setter,
	<EMR>, <LPEMR>, <PEMR>, ptlReference-value,
	ptlReference-value-setter, nChars-value, nChars-value-setter,
	offString-value, offString-value-setter, fOptions-value,
	fOptions-value-setter, rcl-value, rcl-value-setter, offDx-value,
	offDx-value-setter, <EMRTEXT>, <LPEMRTEXT>, <PEMRTEXT>, emr-value,
	emr-value-setter, <EMRABORTPATH>, <LPEMRABORTPATH>, <PEMRABORTPATH>,
	<EMRBEGINPATH>, <PEMRBEGINPATH>, <EMRENDPATH>, <PEMRENDPATH>,
	<EMRCLOSEFIGURE>, <PEMRCLOSEFIGURE>, <EMRFLATTENPATH>,
	<PEMRFLATTENPATH>, <EMRWIDENPATH>, <PEMRWIDENPATH>, <EMRSETMETARGN>,
	<PEMRSETMETARGN>, <EMRSAVEDC>, <PEMRSAVEDC>, <EMRREALIZEPALETTE>,
	<PEMRREALIZEPALETTE>;
  export emr-value, emr-value-setter, iMode-value, iMode-value-setter,
	<EMRSELECTCLIPPATH>, <LPEMRSELECTCLIPPATH>, <PEMRSELECTCLIPPATH>,
	<EMRSETBKMODE>, <PEMRSETBKMODE>, <EMRSETMAPMODE>, <PEMRSETMAPMODE>,
	<EMRSETPOLYFILLMODE>, <PEMRSETPOLYFILLMODE>, <EMRSETROP2>,
	<PEMRSETROP2>, <EMRSETSTRETCHBLTMODE>, <PEMRSETSTRETCHBLTMODE>,
	<EMRSETICMMODE>, <PEMRSETICMMODE>, <EMRSETTEXTALIGN>,
	<PEMRSETTEXTALIGN>;
  export emr-value, emr-value-setter, eMiterLimit-value,
	eMiterLimit-value-setter, <EMRSETMITERLIMIT>, <LPEMRSETMITERLIMIT>,
	<PEMRSETMITERLIMIT>;
  export emr-value, emr-value-setter, iRelative-value,
	iRelative-value-setter, <EMRRESTOREDC>, <LPEMRRESTOREDC>,
	<PEMRRESTOREDC>;
  export emr-value, emr-value-setter, iArcDirection-value,
	iArcDirection-value-setter, <EMRSETARCDIRECTION>,
	<LPEMRSETARCDIRECTION>, <PEMRSETARCDIRECTION>;
  export emr-value, emr-value-setter, <EMRSETMAPPERFLAGS>,
	<LPEMRSETMAPPERFLAGS>, <PEMRSETMAPPERFLAGS>;
  export emr-value, emr-value-setter, crColor-value,
	crColor-value-setter, <EMRSETBKCOLOR>, <LPEMRSETBKCOLOR>,
	<PEMRSETBKCOLOR>, <EMRSETTEXTCOLOR>, <PEMRSETTEXTCOLOR>;
  export emr-value, emr-value-setter, ihObject-value,
	ihObject-value-setter, <EMRSELECTOBJECT>, <LPEMRSELECTOBJECT>,
	<PEMRSELECTOBJECT>, <EMRDELETEOBJECT>, <PEMRDELETEOBJECT>, emr-value,
	emr-value-setter, ihCS-value, ihCS-value-setter,
	<EMRSELECTCOLORSPACE>, <LPEMRSELECTCOLORSPACE>,
	<PEMRSELECTCOLORSPACE>, <EMRDELETECOLORSPACE>,
	<PEMRDELETECOLORSPACE>;
  export emr-value, emr-value-setter, ihPal-value, ihPal-value-setter,
	<EMRSELECTPALETTE>, <LPEMRSELECTPALETTE>, <PEMRSELECTPALETTE>;
  export emr-value, emr-value-setter, ihPal-value, ihPal-value-setter,
	cEntries-value, cEntries-value-setter, <EMRRESIZEPALETTE>,
	<LPEMRRESIZEPALETTE>, <PEMRRESIZEPALETTE>;
  export emr-value, emr-value-setter, ihPal-value, ihPal-value-setter,
	iStart-value, iStart-value-setter, cEntries-value,
	cEntries-value-setter, aPalEntries-array, aPalEntries-array-setter,
	aPalEntries-value, <EMRSETPALETTEENTRIES>, <LPEMRSETPALETTEENTRIES>,
	<PEMRSETPALETTEENTRIES>;
  export emr-value, emr-value-setter, ColorAdjustment-value,
	ColorAdjustment-value-setter, <EMRSETCOLORADJUSTMENT>,
	<LPEMRSETCOLORADJUSTMENT>, <PEMRSETCOLORADJUSTMENT>;
  export emr-value, emr-value-setter, Data-array, Data-array-setter,
	Data-value, <EMRGDICOMMENT>, <LPEMRGDICOMMENT>, <PEMRGDICOMMENT>;
  export emr-value, emr-value-setter, nPalEntries-value,
	nPalEntries-value-setter, offPalEntries-value,
	offPalEntries-value-setter, nSizeLast-value, nSizeLast-value-setter,
	<EMREOF>, <LPEMREOF>, <PEMREOF>;
  export emr-value, emr-value-setter, ptl-value, ptl-value-setter,
	<EMRLINETO>, <LPEMRLINETO>, <PEMRLINETO>, <EMRMOVETOEX>,
	<PEMRMOVETOEX>;
  export emr-value, emr-value-setter, ptlOffset-value,
	ptlOffset-value-setter, <EMROFFSETCLIPRGN>, <LPEMROFFSETCLIPRGN>,
	<PEMROFFSETCLIPRGN>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, <EMRFILLPATH>, <LPEMRFILLPATH>,
	<PEMRFILLPATH>, <EMRSTROKEANDFILLPATH>, <PEMRSTROKEANDFILLPATH>,
	<EMRSTROKEPATH>, <PEMRSTROKEPATH>;
  export emr-value, emr-value-setter, rclClip-value,
	rclClip-value-setter, <EMREXCLUDECLIPRECT>, <LPEMREXCLUDECLIPRECT>,
	<PEMREXCLUDECLIPRECT>, <EMRINTERSECTCLIPRECT>,
	<PEMRINTERSECTCLIPRECT>;
  export emr-value, emr-value-setter, ptlOrigin-value,
	ptlOrigin-value-setter, <EMRSETVIEWPORTORGEX>,
	<LPEMRSETVIEWPORTORGEX>, <PEMRSETVIEWPORTORGEX>, <EMRSETWINDOWORGEX>,
	<PEMRSETWINDOWORGEX>, <EMRSETBRUSHORGEX>, <PEMRSETBRUSHORGEX>;
  export emr-value, emr-value-setter, szlExtent-value,
	szlExtent-value-setter, <EMRSETVIEWPORTEXTEX>,
	<LPEMRSETVIEWPORTEXTEX>, <PEMRSETVIEWPORTEXTEX>, <EMRSETWINDOWEXTEX>,
	<PEMRSETWINDOWEXTEX>;
  export emr-value, emr-value-setter, xNum-value, xNum-value-setter,
	xDenom-value, xDenom-value-setter, yNum-value, yNum-value-setter,
	yDenom-value, yDenom-value-setter, <EMRSCALEVIEWPORTEXTEX>,
	<LPEMRSCALEVIEWPORTEXTEX>, <PEMRSCALEVIEWPORTEXTEX>,
	<EMRSCALEWINDOWEXTEX>, <PEMRSCALEWINDOWEXTEX>;
  export emr-value, emr-value-setter, xform-value, xform-value-setter,
	<EMRSETWORLDTRANSFORM>, <LPEMRSETWORLDTRANSFORM>,
	<PEMRSETWORLDTRANSFORM>;
  export emr-value, emr-value-setter, xform-value, xform-value-setter,
	iMode-value, iMode-value-setter, <EMRMODIFYWORLDTRANSFORM>,
	<LPEMRMODIFYWORLDTRANSFORM>, <PEMRMODIFYWORLDTRANSFORM>;
  export emr-value, emr-value-setter, ptlPixel-value,
	ptlPixel-value-setter, crColor-value, crColor-value-setter,
	<EMRSETPIXELV>, <LPEMRSETPIXELV>, <PEMRSETPIXELV>;
  export emr-value, emr-value-setter, ptlStart-value,
	ptlStart-value-setter, crColor-value, crColor-value-setter,
	iMode-value, iMode-value-setter, <EMREXTFLOODFILL>,
	<LPEMREXTFLOODFILL>, <PEMREXTFLOODFILL>;
  export emr-value, emr-value-setter, rclBox-value,
	rclBox-value-setter, <EMRELLIPSE>, <LPEMRELLIPSE>, <PEMRELLIPSE>,
	<EMRRECTANGLE>, <PEMRRECTANGLE>;
  export emr-value, emr-value-setter, rclBox-value,
	rclBox-value-setter, szlCorner-value, szlCorner-value-setter,
	<EMRROUNDRECT>, <LPEMRROUNDRECT>, <PEMRROUNDRECT>;
  export emr-value, emr-value-setter, rclBox-value,
	rclBox-value-setter, ptlStart-value, ptlStart-value-setter,
	ptlEnd-value, ptlEnd-value-setter, <EMRARC>, <LPEMRARC>, <PEMRARC>,
	<EMRARCTO>, <PEMRARCTO>, <EMRCHORD>, <PEMRCHORD>, <EMRPIE>,
	<PEMRPIE>;
  export emr-value, emr-value-setter, ptlCenter-value,
	ptlCenter-value-setter, nRadius-value, nRadius-value-setter,
	eStartAngle-value, eStartAngle-value-setter, eSweepAngle-value,
	eSweepAngle-value-setter, <EMRANGLEARC>, <LPEMRANGLEARC>,
	<PEMRANGLEARC>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, cptl-value, cptl-value-setter, aptl-array,
	aptl-array-setter, aptl-value, <EMRPOLYLINE>, <LPEMRPOLYLINE>,
	<PEMRPOLYLINE>, <EMRPOLYBEZIER>, <PEMRPOLYBEZIER>, <EMRPOLYGON>,
	<PEMRPOLYGON>, <EMRPOLYBEZIERTO>, <PEMRPOLYBEZIERTO>,
	<EMRPOLYLINETO>, <PEMRPOLYLINETO>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, cpts-value, cpts-value-setter, apts-array,
	apts-array-setter, apts-value, <EMRPOLYLINE16>, <LPEMRPOLYLINE16>,
	<PEMRPOLYLINE16>, <EMRPOLYBEZIER16>, <PEMRPOLYBEZIER16>,
	<EMRPOLYGON16>, <PEMRPOLYGON16>, <EMRPOLYBEZIERTO16>,
	<PEMRPOLYBEZIERTO16>, <EMRPOLYLINETO16>, <PEMRPOLYLINETO16>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, cpts-value, cpts-value-setter, apts-array,
	apts-array-setter, apts-value, abTypes-array, abTypes-array-setter,
	abTypes-value, <EMRPOLYDRAW16>, <LPEMRPOLYDRAW16>, <PEMRPOLYDRAW16>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, nPolys-value, nPolys-value-setter,
	cptl-value, cptl-value-setter, aPolyCounts-array,
	aPolyCounts-array-setter, aPolyCounts-value, aptl-array,
	aptl-array-setter, aptl-value, <EMRPOLYPOLYLINE>,
	<LPEMRPOLYPOLYLINE>, <PEMRPOLYPOLYLINE>, <EMRPOLYPOLYGON>,
	<PEMRPOLYPOLYGON>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, nPolys-value, nPolys-value-setter,
	cpts-value, cpts-value-setter, aPolyCounts-array,
	aPolyCounts-array-setter, aPolyCounts-value, apts-array,
	apts-array-setter, apts-value, <EMRPOLYPOLYLINE16>,
	<LPEMRPOLYPOLYLINE16>, <PEMRPOLYPOLYLINE16>, <EMRPOLYPOLYGON16>,
	<PEMRPOLYPOLYGON16>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, cbRgnData-value, cbRgnData-value-setter,
	RgnData-array, RgnData-array-setter, RgnData-value, <EMRINVERTRGN>,
	<LPEMRINVERTRGN>, <PEMRINVERTRGN>, <EMRPAINTRGN>, <PEMRPAINTRGN>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, cbRgnData-value, cbRgnData-value-setter,
	ihBrush-value, ihBrush-value-setter, RgnData-array,
	RgnData-array-setter, RgnData-value, <EMRFILLRGN>, <LPEMRFILLRGN>,
	<PEMRFILLRGN>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, cbRgnData-value, cbRgnData-value-setter,
	ihBrush-value, ihBrush-value-setter, szlStroke-value,
	szlStroke-value-setter, RgnData-array, RgnData-array-setter,
	RgnData-value, <EMRFRAMERGN>, <LPEMRFRAMERGN>, <PEMRFRAMERGN>;
  export emr-value, emr-value-setter, cbRgnData-value,
	cbRgnData-value-setter, iMode-value, iMode-value-setter,
	RgnData-array, RgnData-array-setter, RgnData-value,
	<EMREXTSELECTCLIPRGN>, <LPEMREXTSELECTCLIPRGN>,
	<PEMREXTSELECTCLIPRGN>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, iGraphicsMode-value,
	iGraphicsMode-value-setter, exScale-value, exScale-value-setter,
	eyScale-value, eyScale-value-setter, emrtext-value,
	emrtext-value-setter, <EMREXTTEXTOUTA>, <LPEMREXTTEXTOUTA>,
	<PEMREXTTEXTOUTA>, <EMREXTTEXTOUTW>, <PEMREXTTEXTOUTW>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, iGraphicsMode-value,
	iGraphicsMode-value-setter, exScale-value, exScale-value-setter,
	eyScale-value, eyScale-value-setter, cStrings-value,
	cStrings-value-setter, aemrtext-array, aemrtext-array-setter,
	aemrtext-value, <EMRPOLYTEXTOUTA>, <LPEMRPOLYTEXTOUTA>,
	<PEMRPOLYTEXTOUTA>, <EMRPOLYTEXTOUTW>, <PEMRPOLYTEXTOUTW>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, xDest-value, xDest-value-setter, yDest-value,
	yDest-value-setter, cxDest-value, cxDest-value-setter, cyDest-value,
	cyDest-value-setter, dwRop-value, dwRop-value-setter, xSrc-value,
	xSrc-value-setter, ySrc-value, ySrc-value-setter, xformSrc-value,
	xformSrc-value-setter, crBkColorSrc-value, crBkColorSrc-value-setter,
	iUsageSrc-value, iUsageSrc-value-setter, offBmiSrc-value,
	offBmiSrc-value-setter, cbBmiSrc-value, cbBmiSrc-value-setter,
	offBitsSrc-value, offBitsSrc-value-setter, cbBitsSrc-value,
	cbBitsSrc-value-setter, <EMRBITBLT>, <LPEMRBITBLT>, <PEMRBITBLT>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, xDest-value, xDest-value-setter, yDest-value,
	yDest-value-setter, cxDest-value, cxDest-value-setter, cyDest-value,
	cyDest-value-setter, dwRop-value, dwRop-value-setter, xSrc-value,
	xSrc-value-setter, ySrc-value, ySrc-value-setter, xformSrc-value,
	xformSrc-value-setter, crBkColorSrc-value, crBkColorSrc-value-setter,
	iUsageSrc-value, iUsageSrc-value-setter, offBmiSrc-value,
	offBmiSrc-value-setter, cbBmiSrc-value, cbBmiSrc-value-setter,
	offBitsSrc-value, offBitsSrc-value-setter, cbBitsSrc-value,
	cbBitsSrc-value-setter, cxSrc-value, cxSrc-value-setter, cySrc-value,
	cySrc-value-setter, <EMRSTRETCHBLT>, <LPEMRSTRETCHBLT>,
	<PEMRSTRETCHBLT>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, xDest-value, xDest-value-setter, yDest-value,
	yDest-value-setter, cxDest-value, cxDest-value-setter, cyDest-value,
	cyDest-value-setter, dwRop-value, dwRop-value-setter, xSrc-value,
	xSrc-value-setter, ySrc-value, ySrc-value-setter, xformSrc-value,
	xformSrc-value-setter, crBkColorSrc-value, crBkColorSrc-value-setter,
	iUsageSrc-value, iUsageSrc-value-setter, offBmiSrc-value,
	offBmiSrc-value-setter, cbBmiSrc-value, cbBmiSrc-value-setter,
	offBitsSrc-value, offBitsSrc-value-setter, cbBitsSrc-value,
	cbBitsSrc-value-setter, xMask-value, xMask-value-setter, yMask-value,
	yMask-value-setter, iUsageMask-value, iUsageMask-value-setter,
	offBmiMask-value, offBmiMask-value-setter, cbBmiMask-value,
	cbBmiMask-value-setter, offBitsMask-value, offBitsMask-value-setter,
	cbBitsMask-value, cbBitsMask-value-setter, <EMRMASKBLT>,
	<LPEMRMASKBLT>, <PEMRMASKBLT>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, aptlDest-array, aptlDest-array-setter,
	aptlDest-value, xSrc-value, xSrc-value-setter, ySrc-value,
	ySrc-value-setter, cxSrc-value, cxSrc-value-setter, cySrc-value,
	cySrc-value-setter, xformSrc-value, xformSrc-value-setter,
	crBkColorSrc-value, crBkColorSrc-value-setter, iUsageSrc-value,
	iUsageSrc-value-setter, offBmiSrc-value, offBmiSrc-value-setter,
	cbBmiSrc-value, cbBmiSrc-value-setter, offBitsSrc-value,
	offBitsSrc-value-setter, cbBitsSrc-value, cbBitsSrc-value-setter,
	xMask-value, xMask-value-setter, yMask-value, yMask-value-setter,
	iUsageMask-value, iUsageMask-value-setter, offBmiMask-value,
	offBmiMask-value-setter, cbBmiMask-value, cbBmiMask-value-setter,
	offBitsMask-value, offBitsMask-value-setter, cbBitsMask-value,
	cbBitsMask-value-setter, <EMRPLGBLT>, <LPEMRPLGBLT>, <PEMRPLGBLT>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, xDest-value, xDest-value-setter, yDest-value,
	yDest-value-setter, xSrc-value, xSrc-value-setter, ySrc-value,
	ySrc-value-setter, cxSrc-value, cxSrc-value-setter, cySrc-value,
	cySrc-value-setter, offBmiSrc-value, offBmiSrc-value-setter,
	cbBmiSrc-value, cbBmiSrc-value-setter, offBitsSrc-value,
	offBitsSrc-value-setter, cbBitsSrc-value, cbBitsSrc-value-setter,
	iUsageSrc-value, iUsageSrc-value-setter, iStartScan-value,
	iStartScan-value-setter, cScans-value, cScans-value-setter,
	<EMRSETDIBITSTODEVICE>, <LPEMRSETDIBITSTODEVICE>,
	<PEMRSETDIBITSTODEVICE>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, xDest-value, xDest-value-setter, yDest-value,
	yDest-value-setter, xSrc-value, xSrc-value-setter, ySrc-value,
	ySrc-value-setter, cxSrc-value, cxSrc-value-setter, cySrc-value,
	cySrc-value-setter, offBmiSrc-value, offBmiSrc-value-setter,
	cbBmiSrc-value, cbBmiSrc-value-setter, offBitsSrc-value,
	offBitsSrc-value-setter, cbBitsSrc-value, cbBitsSrc-value-setter,
	iUsageSrc-value, iUsageSrc-value-setter, dwRop-value,
	dwRop-value-setter, cxDest-value, cxDest-value-setter, cyDest-value,
	cyDest-value-setter, <EMRSTRETCHDIBITS>, <LPEMRSTRETCHDIBITS>,
	<PEMRSTRETCHDIBITS>;
  export emr-value, emr-value-setter, ihPal-value, ihPal-value-setter,
	lgpl-value, lgpl-value-setter, <EMRCREATEPALETTE>,
	<LPEMRCREATEPALETTE>, <PEMRCREATEPALETTE>;
  export emr-value, emr-value-setter, ihPen-value, ihPen-value-setter,
	lopn-value, lopn-value-setter, <EMRCREATEPEN>, <LPEMRCREATEPEN>,
	<PEMRCREATEPEN>;
  export emr-value, emr-value-setter, ihPen-value, ihPen-value-setter,
	offBmi-value, offBmi-value-setter, cbBmi-value, cbBmi-value-setter,
	offBits-value, offBits-value-setter, cbBits-value,
	cbBits-value-setter, elp-value, elp-value-setter, <EMREXTCREATEPEN>,
	<LPEMREXTCREATEPEN>, <PEMREXTCREATEPEN>;
  export emr-value, emr-value-setter, ihBrush-value,
	ihBrush-value-setter, lb-value, lb-value-setter,
	<EMRCREATEBRUSHINDIRECT>, <LPEMRCREATEBRUSHINDIRECT>,
	<PEMRCREATEBRUSHINDIRECT>;
  export emr-value, emr-value-setter, ihBrush-value,
	ihBrush-value-setter, iUsage-value, iUsage-value-setter,
	offBmi-value, offBmi-value-setter, cbBmi-value, cbBmi-value-setter,
	offBits-value, offBits-value-setter, cbBits-value,
	cbBits-value-setter, <EMRCREATEMONOBRUSH>, <LPEMRCREATEMONOBRUSH>,
	<PEMRCREATEMONOBRUSH>;
  export emr-value, emr-value-setter, ihBrush-value,
	ihBrush-value-setter, iUsage-value, iUsage-value-setter,
	offBmi-value, offBmi-value-setter, cbBmi-value, cbBmi-value-setter,
	offBits-value, offBits-value-setter, cbBits-value,
	cbBits-value-setter, <EMRCREATEDIBPATTERNBRUSHPT>,
	<LPEMRCREATEDIBPATTERNBRUSHPT>, <PEMRCREATEDIBPATTERNBRUSHPT>;
  export dSignature-value, dSignature-value-setter, nVersion-value,
	nVersion-value-setter, offData-value, offData-value-setter,
	<EMRFORMAT>, <LPEMRFORMAT>, <PEMRFORMAT>;
  export emr-value, emr-value-setter, Data-array, Data-array-setter,
	Data-value, <EMRGLSRECORD>, <LPEMRGLSRECORD>, <PEMRGLSRECORD>;
  export emr-value, emr-value-setter, rclBounds-value,
	rclBounds-value-setter, Data-array, Data-array-setter, Data-value,
	<EMRGLSBOUNDEDRECORD>, <LPEMRGLSBOUNDEDRECORD>,
	<PEMRGLSBOUNDEDRECORD>;
  export emr-value, emr-value-setter, pfd-value, pfd-value-setter,
	<EMRPIXELFORMAT>, <LPEMRPIXELFORMAT>, <PEMRPIXELFORMAT>,
	$SETICMPROFILE-EMBEDED, emr-value, emr-value-setter, cbName-value,
	cbName-value-setter, Data-array, Data-array-setter, Data-value,
	<EMRSETICMPROFILE>, <LPEMRSETICMPROFILE>, <PEMRSETICMPROFILE>,
	$GDICOMMENT-IDENTIFIER, $GDICOMMENT-WINDOWS-METAFILE,
	$GDICOMMENT-BEGINGROUP, $GDICOMMENT-ENDGROUP,
	$GDICOMMENT-MULTIFORMATS, $EPS-SIGNATURE, SwapBuffers;
  export <POINTFLOAT>, <LPPOINTFLOAT>, <PPOINTFLOAT>;
  export gmfBlackBoxX-value, gmfBlackBoxX-value-setter,
	gmfBlackBoxY-value, gmfBlackBoxY-value-setter,
	gmfptGlyphOrigin-value, gmfptGlyphOrigin-value-setter,
	gmfCellIncX-value, gmfCellIncX-value-setter, gmfCellIncY-value,
	gmfCellIncY-value-setter, <GLYPHMETRICSFLOAT>, <LPGLYPHMETRICSFLOAT>,
	<PGLYPHMETRICSFLOAT>, $WGL-FONT-LINES, $WGL-FONT-POLYGONS,
	nSize-value, nSize-value-setter, nVersion-value,
	nVersion-value-setter, iPixelType-value, iPixelType-value-setter,
	cColorBits-value, cColorBits-value-setter, cRedBits-value,
	cRedBits-value-setter, cRedShift-value, cRedShift-value-setter,
	cGreenBits-value, cGreenBits-value-setter, cGreenShift-value,
	cGreenShift-value-setter, cBlueBits-value, cBlueBits-value-setter,
	cBlueShift-value, cBlueShift-value-setter, cAlphaBits-value,
	cAlphaBits-value-setter, cAlphaShift-value, cAlphaShift-value-setter,
	cAccumBits-value, cAccumBits-value-setter, cAccumRedBits-value,
	cAccumRedBits-value-setter, cAccumGreenBits-value,
	cAccumGreenBits-value-setter, cAccumBlueBits-value,
	cAccumBlueBits-value-setter, cAccumAlphaBits-value,
	cAccumAlphaBits-value-setter, cDepthBits-value,
	cDepthBits-value-setter, cStencilBits-value,
	cStencilBits-value-setter, cAuxBuffers-value,
	cAuxBuffers-value-setter, iLayerPlane-value,
	iLayerPlane-value-setter, crTransparent-value,
	crTransparent-value-setter, <LAYERPLANEDESCRIPTOR>,
	<LPLAYERPLANEDESCRIPTOR>, <PLAYERPLANEDESCRIPTOR>, $LPD-DOUBLEBUFFER,
	$LPD-STEREO, $LPD-SUPPORT-GDI, $LPD-SUPPORT-OPENGL, $LPD-SHARE-DEPTH,
	$LPD-SHARE-STENCIL, $LPD-SHARE-ACCUM, $LPD-SWAP-EXCHANGE,
	$LPD-SWAP-COPY, $LPD-TRANSPARENT, $LPD-TYPE-RGBA,
	$LPD-TYPE-COLORINDEX;

  // defined in "moregdi.dylan":
  export RGB, PALETTERGB, PALETTEINDEX, GetRValue, GetGValue, GetBValue;
  export TextOutW, GetTextExtentPoint32W;

  // shared accessors declared in "pregdi.dylan":
  export lStructSize-value, dwType-value,
    lStructSize-value-setter, dwType-value-setter;

end module Win32-GDI;
